# RTLS SiteWise

<!-- START doctoc generated TOC please keep comment here to allow auto update -->
<!-- DON'T EDIT THIS SECTION, INSTEAD RE-RUN doctoc TO UPDATE -->

- [Usage](#usage)
    - [Running the Service Locally](#running-the-service-locally)
- [Running Tests](#running-tests)
- [Package Release](#package-release)
    - [Sitewise](#sitewise)
- [Setup and execute on dev centralize sitewise](#setup-and-execute-on-dev-centralize-sitewise)
    - [rtls-sitewise-portal](#rtls-sitewise-portal)
        - [Version](#version)
        - [nginx](#nginx)
        - [Build sitewise](#build-sitewise)
            - [Server](#server)

<!-- END doctoc generated TOC please keep comment here to allow auto update -->

## Usage

### Running the Service Locally

- install client node packages

```shell
npm install --legacy-peer-deps --prefix=client

```

- build client

```shell
npm run build:dev --prefix=client

```

- run client in `serve` mode. Available in hot mode on port `http://localhost:8086`

```shell
npm run serve --prefix=client

```

## Running Tests

```shell
npm test --prefix=client

```

## Package Release

### Sitewise

- Reset all current changes, checkout and update current development branch(`dev`)

```shell
git checkout -- ./
git checkout dev
git pull origin dev

```

- Update [CHANGELOG.md](CHANGELOG.md) to add release date to latest version

- Run scripts for version increment

```shell
cd ./client 
yarn version:patch

```

- Create new build branch (`master_client`)

```shell
git branch -D master_client
git branch master_client

```

- Make **force push**(for the case if `master_client` branch already exists from branch differ than `dev`)

```shell
git push origin master_client -f 

```

- Check build progress
  in [jenkins](https://jenkins.rpplabs.com/job/rtls-web-team/job/rtls-frontend-sitewise/job/master_client/)
- After build complete package will locate in [repository](https://repo.rpplabs.com/ubuntu/)  as `rtls-frontend*`

## Setup and execute on dev centralize sitewise

### rtls-sitewise-portal

* go to [jenkins config](https://jenkins.rpplabs.com/manage/configure)
* find `RTLS_CENTRALIZED_SITEWISE_DEV_SERVER` value
* go to this server from jump-box

```shell
ssh ubuntu@<RTLS_CENTRALIZED_SITEWISE_DEV_SERVER>

```

#### Version

* Add new Sitewise `Version` to dropdown list on <RTLS_CENTRALIZED_SITEWISE_DEV_SERVER>

```shell
sudo vim /etc/rtls/rtls-sitewise-versions.json

```

* New `version` value

```text
{ "value": "v<X.X.X>", "title": "v<X.X.X> (comment)" }

```

#### nginx

```shell
sudo vim /etc/nginx/sites-enabled/default

```

* add section to `version` value

```text
location /app/v<X.X.X> {
        alias /home/rtls/rtls-frontend/v<X.X.X>/client/build;
        index index.html index.htm;
        try_files $uri $uri/ /app/v<X.X.X>/index.html;
}

```

* reload

```shell
sudo systemctl restart nginx

```

#### Build sitewise

* Go to rtls-frontend repository
* Update `CiClient.jenkinsfile`
* Add your branch to trigger build `branch '<your_branch>'` next to `branch 'deploy_dev'`
* Override `env.TAG_NAME`

```text
env.TAG_NAME = '<X.X.X>'

```

* Push branch

##### Server

* Add new server (if you require)

```shell
sudo cat /etc/rtls/rtls-available-servers.json

```

* server value in `servers` array

```text
{ "hostname": "<SERVER-NAME>.rpplabs.com", "displayName": "<SERVER-NAME>" }

```
