module.exports = {
    testEnvironment: 'jsdom',
    moduleFileExtensions: [
        'js',
        'json',
        'jsx',
        'ts',
        'tsx',
        'node',
    ],
    moduleNameMapper: {
        '^spaghetti(.*)': '<rootDir>/src/modules/spaghetti$1',
        '^playback(.*)': '<rootDir>/src/modules/playback$1',
        '^worker-loader(.*)$': '<rootDir>/node_modules/worker-loader',
        '^worker(.*)$': '<rootDir>/src/modules/worker$1',
        '^near-miss-events(.*)$': '<rootDir>/src/modules/near-miss-events$1',
        '^api(.*)$': '<rootDir>/src/modules/api$1',
        '^common(.*)$': '<rootDir>/src/js/common$1',
        '^components(.*)$': '<rootDir>/src/js/components$1',
        '^modals(.*)$': '<rootDir>/src/js/modals$1',
        '^pages(.*)$': '<rootDir>/src/js/pages$1',
        '^stores(.*)$': '<rootDir>/src/js/stores$1',
        '^utils(.*)$': '<rootDir>/src/js/utils$1',
        '\\.(css|less|scss|sass)$': 'identity-obj-proxy',
    },
    transformIgnorePatterns: [
        'node_modules',
    ],
    coverageThreshold: {
        './src/js/stores/reducers/**/*': {
            branches: 50,
            functions: 50,
            lines: 50,
            statements: 60,
        },
    },
    collectCoverageFrom: [
        'src/**/*.{js,jsx}',
        '!src/js/{components,modals,pages}/**/*.{js,jsx}',
        '!src/js/stores/reducers/modals/**/*.{js,jsx}',
        '!src/modules/api/**/*.{js,jsx}',
    ],
};
