const { modules_list } = require('../../features/featuresList');

const modules_tabs = {};
const module_routes = {};

if (Array.isArray(modules_list) && modules_list.length > 0) {
    modules_list.forEach((module) => {
        if (module && module.tabs && module.tabs.systemName) {
            modules_tabs[module.tabs.systemName] = module.component;
        }
        if (module && module.route) {
            module_routes[module.route.to] = module.component;
        }
    });
}

export default {
    tabs: modules_tabs,
    routes: module_routes,
};

//  FORMAT OF EXPORT IN ROUTE ADDING MODULE
// export default {
//     user_role: [ USER_ROLES.RPP_ADMIN, USER_ROLES.PROJECT_OPERATIONS_ADMIN, USER_ROLES.PROJECT_SYSTEM_ADMIN ],
//     route: { to: '/feature_two', label: 'FeatureTwo' },
//     component: App,
// };
//
//  FORMAT OF EXPORT IN TAB ADDING MODULE
// export default {
//     user_role: [ USER_ROLES.RPP_ADMIN, USER_ROLES.PROJECT_OPERATIONS_ADMIN, USER_ROLES.PROJECT_SYSTEM_ADMIN ],
//     tabs: {
//         page: '/admin',
//         name: 'Addone one',
//         systemName: 'FEATURE_ONE',
//     },
//     component: App,
// };
