import { geometryFromDegreesToMillimeters, rotateGeometry, setWidthToGeometry } from 'utils/zoneUtils';

export function formatZoneGeometryOnCreate(creatingZone, rotation, width) {
    const rotatedGeometry = {
        creatingZone,
    };
    if (creatingZone && creatingZone.zoneGeometryInDegrees.length === 2) {
        const { geometry } = setWidthToGeometry(creatingZone, width);
        rotatedGeometry.creatingZone = { zoneGeometryInDegrees: geometry };
    }
    const geometryAsObjects = rotateGeometry(rotatedGeometry.creatingZone, rotation).map(point => ({ lng: point[1], lat: point[0] }));
    return geometryFromDegreesToMillimeters(geometryAsObjects);
}
