import {
    DASHBOARD,
    ADMIN_TABS_NAME,
    ADMIN_TABS_ROUTES,
    SYSTEM_TABS_NAMES,
    SYSTEM_TABS_ROUTES,
    SYSTEM_TAB_BUTTONS,
    LOGGER_TABS_NAME,
    LOGGER_TABS_ROUTES,
    ROUTING_REPORT_TYPE,
    REPORT_PATH, ROUTES,
} from './constants';
import { NAME_OF_GEAR_BUTTONS, NAME_OF_NAV_BUTTONS, NAMES_OF_TABS, REPORTS_SIDE_BAR, SYSTEM_PAGE } from './ui-labels';


export const WIDGETS = {
    [DASHBOARD.CURRENT_ALARMS_WIDGET]: {
        name: DASHBOARD.CURRENT_ALARMS_WIDGET,
        active: true,
        isExpanded: false,
    },
    [DASHBOARD.WIN_STATUS_WIDGET]: {
        name: DASHBOARD.WIN_STATUS_WIDGET,
        active: true,
        isExpanded: false,
    },
    [DASHBOARD.CURRENT_SHIFT_WIDGET]: {
        name: DASHBOARD.CURRENT_SHIFT_WIDGET,
        active: true,
        isExpanded: false,
    },
    [DASHBOARD.PERSON_ACTIVITY_WIDGET]: {
        name: DASHBOARD.PERSON_ACTIVITY_WIDGET,
        active: true,
        isExpanded: false,
    },
};

export const ADMIN_PAGES = {
    [ADMIN_TABS_NAME.COMPANIES]: {
        name: NAMES_OF_TABS.COMPANIES,
        systemName: ADMIN_TABS_NAME.COMPANIES,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.COMPANIES.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.COMPANIES,
    },
    [ADMIN_TABS_NAME.SUPER_ADMIN_USERS]: {
        name: NAMES_OF_TABS.SUPER_ADMIN_USERS,
        systemName: ADMIN_TABS_NAME.SUPER_ADMIN_USERS,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.SUPER_ADMIN_USERS.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.SUPER_ADMIN_USERS,
    },
    [ADMIN_TABS_NAME.PROJECTS]: {
        name: NAMES_OF_TABS.PROJECTS,
        systemName: ADMIN_TABS_NAME.PROJECTS,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.PROJECTS.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.PROJECTS,
    },
    [ADMIN_TABS_NAME.USERS_PROJECT_SCOPE]: {
        name: NAMES_OF_TABS.USERS_PROJECT_SCOPE,
        systemName: ADMIN_TABS_NAME.USERS_PROJECT_SCOPE,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.USERS_PROJECT_SCOPE.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.USERS_PROJECT_SCOPE,
    },
    [ADMIN_TABS_NAME.TRACKABLE_OBJECTS]: {
        name: NAMES_OF_TABS.TRACKABLE_OBJECTS,
        systemName: ADMIN_TABS_NAME.TRACKABLE_OBJECTS,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.TRACKABLE_OBJECTS.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.TRACKABLE_OBJECTS,
    },
    [ADMIN_TABS_NAME.GROUPS]: {
        name: NAMES_OF_TABS.GROUPS,
        systemName: ADMIN_TABS_NAME.GROUPS,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.GROUPS.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.GROUPS,
    },
    [ADMIN_TABS_NAME.ZONES]: {
        name: NAMES_OF_TABS.ZONES,
        systemName: ADMIN_TABS_NAME.ZONES,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.ZONES.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.ZONES,
    },
    [ADMIN_TABS_NAME.NOTIFICATIONS]: {
        name: NAMES_OF_TABS.NOTIFICATIONS,
        systemName: ADMIN_TABS_NAME.NOTIFICATIONS,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.NOTIFICATIONS.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.NOTIFICATIONS,
    },
    [ADMIN_TABS_NAME.NODES]: {
        name: NAMES_OF_TABS.NODES,
        systemName: ADMIN_TABS_NAME.NODES,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.NODES.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.NODES,
    },
    [ADMIN_TABS_NAME.SHIFTS]: {
        name: NAMES_OF_TABS.SHIFTS,
        systemName: ADMIN_TABS_NAME.SHIFTS,
        dataCy: `nav_submenu_admin_${ADMIN_TABS_NAME.SHIFTS.toLowerCase()}`,
        path: ADMIN_TABS_ROUTES.SHIFTS,
    },
};

export const SYSTEM_PAGES = {
    [SYSTEM_TABS_NAMES.SERVER]: {
        name: SYSTEM_PAGE.SERVER,
        systemName: SYSTEM_TABS_NAMES.SERVER,
        dataCy: `nav_submenu_system_${SYSTEM_TABS_NAMES.SERVER.toLowerCase()}`,
        path: SYSTEM_TABS_ROUTES.SERVER,
    },
    [SYSTEM_TABS_NAMES.ANCHORS]: {
        name: SYSTEM_PAGE.ANCHORS,
        systemName: SYSTEM_TABS_NAMES.ANCHORS,
        dataCy: `nav_submenu_system_${SYSTEM_TABS_NAMES.ANCHORS.toLowerCase()}`,
        path: SYSTEM_TABS_ROUTES.ANCHORS,
    }
};

export const REPORT_PAGES = {
    [ROUTING_REPORT_TYPE.ATTENDANCE]: {
        name: REPORTS_SIDE_BAR.ATTENDANCE,
        systemName: ROUTING_REPORT_TYPE.ATTENDANCE,
        path: REPORT_PATH.ATTENDANCE,
        dataCy: `nav_submenu_report_${ROUTING_REPORT_TYPE.ATTENDANCE.toLowerCase()}`,
        iconClass: 'far fa-clock',
    },
    [ROUTING_REPORT_TYPE.ALARMS]: {
        name: REPORTS_SIDE_BAR.ALARMS,
        systemName: ROUTING_REPORT_TYPE.ALARMS,
        path: REPORT_PATH.ALARMS,
        dataCy: `nav_submenu_report_${ROUTING_REPORT_TYPE.ALARMS.toLowerCase()}`,
        iconClass: 'fas fa-bell',
    },
    [ROUTING_REPORT_TYPE.PWS]: {
        name: REPORTS_SIDE_BAR.PWS,
        systemName: ROUTING_REPORT_TYPE.PWS,
        path: REPORT_PATH.PWS,
        dataCy: `nav_submenu_report_${ROUTING_REPORT_TYPE.PWS.toLowerCase()}`,
        iconClass: 'fas fa-people-arrows',
    },
    [ROUTING_REPORT_TYPE.ZONE_ACTIVITY]: {
        name: REPORTS_SIDE_BAR.ZONE_ACTIVITY,
        systemName: ROUTING_REPORT_TYPE.ZONE_ACTIVITY,
        path: REPORT_PATH.ZONE_ACTIVITY,
        dataCy: `nav_submenu_report_${ROUTING_REPORT_TYPE.ZONE_ACTIVITY.toLowerCase()}`,
        iconClass: 'fas fa-vector-square inner-i',
    },
};

export const LOGGER_PAGE_TABS = {
    LOGS: {
        name: 'Logs',
        systemName: LOGGER_TABS_NAME.LOGS,
        path: LOGGER_TABS_ROUTES.LOGS,
    },
    ACTIVITIES: {
        name: 'Activities',
        systemName: LOGGER_TABS_NAME.ACTIVITIES,
        path: LOGGER_TABS_ROUTES.ACTIVITIES,
    },
    MESSAGE_PROCESSOR: {
        name: 'Message Processor',
        systemName: LOGGER_TABS_NAME.MESSAGE_PROCESSOR,
        path: LOGGER_TABS_ROUTES.MESSAGE_PROCESSOR,
    },
    DEBUG: {
        name: 'Custom Debug',
        systemName: LOGGER_TABS_NAME.DEBUG,
        path: LOGGER_TABS_ROUTES.DEBUG,
    },
    API: {
        name: 'API',
        systemName: LOGGER_TABS_NAME.API,
        path: LOGGER_TABS_ROUTES.API,
    },
    LEVELS: {
        name: 'LEVELS',
        systemName: LOGGER_TABS_NAME.LEVELS,
        path: LOGGER_TABS_ROUTES.LEVELS,
    },
};

export const NAV_BUTTONS = {
    SYSTEM: {
        label: NAME_OF_NAV_BUTTONS.SYSTEM,
        title: NAME_OF_NAV_BUTTONS.SYSTEM_TITLE,
        to: ROUTES.SYSTEM_ROUTE,
        isButton: true,
        dataCy: 'nav_menu_system',
        iconClass: 'fas fa-server',
    },
    SYSTEM_SITE_MONITOR: {
        label: SYSTEM_PAGE.SITE_MONITOR,
        name: SYSTEM_TAB_BUTTONS.SITE_MONITOR,
        linkIconClass: 'fas fa-link',
        dataCy: 'nav_submenu_system_site_monitor',
        button: true,
    },
    ADMIN: {
        label: NAME_OF_NAV_BUTTONS.ADMINISTRATIONS,
        title: NAME_OF_NAV_BUTTONS.ADMINISTRATIONS_TITLE,
        to: ROUTES.ADMIN_ROUTE,
        isButton: true,
        dataCy: 'nav_menu_admin',
        iconClass: 'fas fa-cogs',
    },
    REPORTS: {
        label: NAME_OF_NAV_BUTTONS.REPORTS,
        title: NAME_OF_NAV_BUTTONS.REPORTS_TITLE,
        to: ROUTES.REPORTS_ROUTE,
        isButton: true,
        dataCy: 'nav_menu_report',
        iconClass: 'far fa-file-alt',
    },
    SITE: {
        label: NAME_OF_NAV_BUTTONS.SITE,
        title: NAME_OF_NAV_BUTTONS.SITE_TITLE,
        to: ROUTES.SITE_ROUTE,
        iconClass: 'fas fa-map-marked-alt',
        dataCy: 'nav_menu_site',
        expandable: true,
    },
    DASHBOARD: {
        label: NAME_OF_NAV_BUTTONS.DASHBOARD,
        title: NAME_OF_NAV_BUTTONS.DASHBOARD_TITLE,
        to: ROUTES.DASHBOARD_ROUTE,
        iconClass: 'fas fa-chart-bar',
        dataCy: 'nav_menu_dashboard',
        expandable: true,
    },
    LOGGER: {
        label: 'Logger',
        to: ROUTES.LOGGER_ROUTE,
        dataCy: 'nav_menu_logger',
        iconClass: 'fas fa-book-dead',
    }
};

export const USER_SUBMENU_BUTTONS = {
    EDIT_COMPANY: {
        label: NAME_OF_GEAR_BUTTONS.EDIT_COMPANY,
        iconClass: 'fas fa-building',
        subIconClass: 'fas fa-pencil-alt',
        dataId: 'user_menu_company_edit_company',
        onClick: () => { console.error('Replace with implementation'); },
    },
    RETURN_TO_COMPANY_PAGE: {
        label: NAME_OF_GEAR_BUTTONS.RETURN_TO_COMPANY_PAGE,
        iconClass: 'fas fa-directions',
        dataId: 'user_menu_company_submenu_back',
        onClick: () => { console.error('Replace with implementation'); },
    },
    EDIT_PROFILE: {
        label: NAME_OF_GEAR_BUTTONS.EDIT_PROFILE,
        iconClass: 'fas fa-user-edit',
        dataId: 'user_menu_user_submenu_edit_profile',
        onClick: () => { console.error('Replace with implementation'); },
    },
    SIGN_OUT: {
        label: NAME_OF_GEAR_BUTTONS.SIGN_OUT,
        iconClass: 'fas fa-sign-out-alt',
        dataId: 'user_menu_user_submenu_sign_out',
        onClick: () => { console.error('Replace with implementation'); },
    },
    USER_GUIDE: {
        label: NAME_OF_GEAR_BUTTONS.HELP_USER_GUIDE_PDF,
        iconClass: 'far fa-file-alt',
        dataId: 'user_menu_help_submenu_pdf',
        onClick: () => { console.error('Replace with implementation'); },
    },
}

export const USER_MENU_BUTTONS = {
    HELP: {
        label: NAME_OF_GEAR_BUTTONS.HELP_BUTTON,
        title: NAME_OF_GEAR_BUTTONS.HELP_BUTTON_TITLE,
        iconClass: 'far fa-question-circle',
        dataId: 'user_menu_help',
        submenu: [],
    },
    USER: {
        label: NAME_OF_GEAR_BUTTONS.USER_PROFILE,
        title: NAME_OF_GEAR_BUTTONS.USER_PROFILE,
        iconClass: 'fas fa-user',
        dataId: 'user_menu_user',
        submenu: [],
    },
    COMPANY: {
        label: NAME_OF_GEAR_BUTTONS.COMPANY,
        dataId: 'user_menu_company',
        title: NAME_OF_GEAR_BUTTONS.COMPANY_TITLE,
        iconClass: 'fas fa-building',
        submenu: [],
    }
};
