import React from 'react';
import PropTypes from 'prop-types';
import Typography from '@material-ui/core/Typography';
import Box from '@material-ui/core/Box';

function CustomTabPanel(props) {
    const { children, value, index, ...other } = props;

    return (
        <Typography
            component="div"
            role="tabpanel"
            hidden={value !== index}
            id={`simple-tabpanel-${index}`}
            aria-labelledby={`simple-tab-${index}`}
            {...other}
        >
            <Box
                p={3}
                hidden={value !== index}
            >
                {children}
            </Box>
        </Typography>
    );
}

CustomTabPanel.propTypes = {
    children: PropTypes.oneOfType([
        PropTypes.arrayOf(PropTypes.node),
        PropTypes.node,
    ]),
    value: PropTypes.number,
    index: PropTypes.number,
};

CustomTabPanel.defaultProps = {
    children: [],
    value: 0,
    index: 0,
};

export default CustomTabPanel;
