import React from 'react';
import Switch from 'react-switch';
import PropTypes from 'prop-types';

import { DASHBOARD_WIDGET_NAME } from '../common';

const DashboardToggle = (props) => {
    const {
        active, onToggle, name, dataCy,
    } = props;
    
    return (
        <div className={`Dashboard-Toggle ${name.toLowerCase()}`}>
            <div className="Toggle-Text">{DASHBOARD_WIDGET_NAME[name]}</div>
            <div
                className="Toggle-Button"
                data-cy={dataCy}
                data-collapsed={!active}
            >
                <Switch
                    checked={active}
                    onChange={onToggle}
                    handleDiameter={20}
                    offColor="#bebebe"
                    height={30}
                    width={50}
                    className={`react-switch ${active ? 'checked' : ''}`}
                    id="small-radius-switch"
                />
            </div>
        </div>);
};

DashboardToggle.propTypes = {
    active: PropTypes.bool,
    name: PropTypes.string,
    dataCy: PropTypes.string,
    onToggle: PropTypes.func,
};

DashboardToggle.defaultProps = {
    active: false,
    name: '',
    dataCy: '',
    onToggle: () => {
    },
};

export default DashboardToggle;
