import React from 'react';
import PropTypes from 'prop-types';


const ExpandColumnComponent = ({ isExpandableRow, isExpanded }) => {
    let content = '';
    
    if (isExpandableRow) {
        content = (isExpanded ?
            <i className="fa fa-angle-up" aria-hidden="true" data-info="not-selectable" /> :
            <i className="fa fa-angle-down" aria-hidden="true" data-info="not-selectable" />);
    } else {
        content = ' ';
    }
    return (
        <div className="text-center" data-info="not-selectable"> {content} </div>
    );
};

ExpandColumnComponent.defaultProps = {
    isExpandableRow: false,
    isExpanded: false,
};

ExpandColumnComponent.propTypes = {
    isExpandableRow: PropTypes.bool,
    isExpanded: PropTypes.bool,
};

export default ExpandColumnComponent;
