import React from 'react';
import PropTypes from 'prop-types';

class LiveButton extends React.PureComponent {
    static propTypes = {
        isRealTimeOn: PropTypes.bool,
        stopStartLiveMode: PropTypes.func,
        access: PropTypes.shape(),
    };
    
    static defaultProps = {
        isRealTimeOn: {},
        stopStartLiveMode: () => {
        },
        access: {},
    };
    
    render() {
        // Check is user login and have the project or company
        if (this.props.access && this.props.access.currentRole) {
            return (
                <div
                    className={`Nav-LiveButton ${this.props.isRealTimeOn ? 'Nav-LiveButton-On' : ''}`}
                    onClick={this.props.stopStartLiveMode}
                >
                    <i className="fa fa-rss" />
                </div>
            );
        }
        return (
            <div className="Nav-LiveButton"><i className="fa fa-rss" /></div>
        );
    }
}

export default LiveButton;
