import React, { Fragment } from 'react';
import PropTypes from 'prop-types';
import DefaultSubmenu from './DefaultSubmenu';
import SitePageSubmenu from './SitePageSubmenu';
import DashboardSubmenu from './DashboardSubmenu';

function Submenu(props) {
    const { item, id, currentPathname, monitorLink } = props;
    return (
        <>
            <DefaultSubmenu
                item={item}
                id={id}
                currentPathname={currentPathname}
                monitorLink={monitorLink}
                closeAllNavBarMenus={props.closeAllNavBarMenus}
                getNavBarMenuOpenCloseStatus={props.getNavBarMenuOpenCloseStatus}
                setNavBarMenuOpenCloseStatus={props.setNavBarMenuOpenCloseStatus}
            />
            <SitePageSubmenu
                item={item}
                id={id}
                setNavBarMenuOpenCloseStatus={props.setNavBarMenuOpenCloseStatus}
                getNavBarMenuOpenCloseStatus={props.getNavBarMenuOpenCloseStatus}
            />
            <DashboardSubmenu
                item={item}
                id={id}
                setNavBarMenuOpenCloseStatus={props.setNavBarMenuOpenCloseStatus}
                getNavBarMenuOpenCloseStatus={props.getNavBarMenuOpenCloseStatus}
            />
        </>
    );
}

Submenu.propTypes = {
    item: PropTypes.shape({
        to: PropTypes.string,
        submenu: PropTypes.arrayOf(PropTypes.shape({})),
    }),
    id: PropTypes.number,
    currentPathname: PropTypes.string,
    monitorLink: PropTypes.string,
    closeAllNavBarMenus: PropTypes.func,
    getNavBarMenuOpenCloseStatus: PropTypes.func,
    setNavBarMenuOpenCloseStatus: PropTypes.func,
};

Submenu.defaultProps = {
    item: {
        to: '',
        submenu: [],
    },
    id: 0,
    currentPathname: '',
    monitorLink: '',
    closeAllNavBarMenus: () => {
    },
    getNavBarMenuOpenCloseStatus: () => {
    },
    setNavBarMenuOpenCloseStatus: () => {
    },
};

export default Submenu;
