import React, { Fragment } from 'react';
import OverlayTrigger from 'react-bootstrap/OverlayTrigger';
import Tooltip from 'react-bootstrap/Tooltip';
import PropTypes from 'prop-types';

const RenderTooltipHelper = ({ tooltipText, color, placement = 'top', delay = { show: 250 } }) => {
    const renderTooltip = props => (<Tooltip {...props}> {tooltipText} </Tooltip>);

    return (
        <Fragment>
            <OverlayTrigger
                placement={placement}
                delay={delay}
                overlay={renderTooltip}
            >
                <i className="fas fa-question-circle field-help-tooltip margin-l-xs" style={{ color }} />
            </OverlayTrigger>
        </Fragment>
    );
};

RenderTooltipHelper.propTypes = {
    tooltipText: PropTypes.oneOf([PropTypes.string, PropTypes.shape({})]),
    color: PropTypes.string,
    placement: PropTypes.string,
    delay: PropTypes.shape({
        show: PropTypes.number,
    }),
};

RenderTooltipHelper.defaultProps = {
    tooltipText: '',
    color: '',
    placement: 'top',
    delay: {
        show: 250,
    },
};

export default RenderTooltipHelper;
