import React from 'react';
import PropTypes from 'prop-types';
import Select from 'react-select';
import 'react-select/dist/react-select.css';

const SmallSelect = (props) => {
    const { options, placeholder, value, className, onChange, disabled } = props;
    return (
        <Select
            options={options}
            className={`small-select ${className}`}
            placeholder={placeholder}
            value={value}
            onChange={onChange}
            disabled={disabled}
            clearable={false}
            searchable={false}
        />
    );
};

SmallSelect.propTypes = {
    options: PropTypes.arrayOf(PropTypes.shape({})),
    value: PropTypes.oneOfType([
        PropTypes.string,
        PropTypes.number,
    ]),
    className: PropTypes.string,
    placeholder: PropTypes.string,
    disabled: PropTypes.bool,
    onChange: PropTypes.func,
};

SmallSelect.defaultProps = {
    options: [],
    value: '',
    className: '',
    placeholder: '',
    disabled: false,
    onChange: () => {},
};

export default SmallSelect;
