import React from 'react';
import PropTypes from 'prop-types';

export function Spinner({ style, show }) {
    if (!show) {
        return null;
    }
    return (
        <i className="fa fa-spinner fa-spin" style={{ color: 'grey', ...style }} />
    );
}

Spinner.propTypes = {
    style: PropTypes.shape({}),
    show: PropTypes.bool,
};

Spinner.defaultProps = {
    style: {},
    show: false,
};
