import React from 'react';
import PropTypes from 'prop-types';


export default function Layout(props) {
    const { renderNavBar, renderMainContent } = props;
    return (
        <div className="RPP-AppLayout">
            <div>{renderNavBar()}</div>
            <div className="RPP-Content">{renderMainContent()}</div>
        </div>
    );
}

Layout.propTypes = {
    renderNavBar: PropTypes.func,
    renderMainContent: PropTypes.func,
};

Layout.defaultProps = {
    renderNavBar: () => {},
    renderMainContent: () => {},
};
