import PropTypes from 'prop-types';
import { ImageOverlay } from 'react-leaflet';

const frontImageOverlay = function _frontImageOverlay(url, bounds, options) {
    return new L.FrontImageOverlay(url, bounds, options);
};
L.FrontImageOverlay = L.ImageOverlay.extend({
    _animateZoom(e) {
        L.ImageOverlay.prototype._animateZoom.call(this, e);
        L.ImageOverlay.prototype.bringToFront.call(this);
    },
    _reset() {
        L.ImageOverlay.prototype._reset.call(this);
        L.ImageOverlay.prototype.bringToFront.call(this);
    },
});


export default class HeatmapImageOverlay extends ImageOverlay {
  static propTypes = {
      attribution: PropTypes.string,
      opacity: PropTypes.number,
      url: PropTypes.string.isRequired,
  };

  constructor(props) {
      super(props);
      this.loadContext = this.loadContext.bind(this);
      this.state = this.loadContext();
      this._leafletEvents = this.extractLeafletEvents(this.props);
      this.leafletElement = frontImageOverlay(this.state.url, this.state.bounds, Object.assign({}, this.state));
  }

  componentWillUnmount() {
      super.componentWillUnmount();
  }

  loadContext() {
      const { bounds } = this.props;

      return {
          rotation: 0,
          bounds,
          url: this.props.url,
          layerName: this.props.url,
      };
  }
}
