import React from 'react';
import PropTypes from 'prop-types';
import { PopUpWrapper } from 'components/leaflet/PopUpWrapper';
import ZonesPopUpTable from 'pages/site/tables/zones/ZonesPopUpTable';

export function ZonesPopUp(props) {
    const { position, onClose, zones, handleZoneClick } = props;
    if (!zones || zones.length === 0) return null;

    return <PopUpWrapper
        position={position}
        closeButton={false}
        onClose={onClose}
        className="RPP-BlockBody"
    >
        <div className="RPP-BlockBody-Wrapper-Zones" onClick={(e) => { e.preventDefault(); }}>
            <div className="RPP-BlockHeader">
                <button
                    type="button"
                    className="RPP-BtnPopUp"
                    onClick={onClose}
                >
                    <i className="fa fa-times" />
                </button>
            </div>
            <div className="RPP-PopUpRowsWrapper">
                <ZonesPopUpTable zones={zones}  handleRowClick={handleZoneClick} />
            </div>
        </div>
    </PopUpWrapper>
}

ZonesPopUp.propTypes = {
    position: PropTypes.shape({}),
    onClose: PropTypes.func,
    zones: PropTypes.arrayOf(PropTypes.shape({})),
    handleZoneClick: PropTypes.func,
}

ZonesPopUp.defaultProps = {
    position: null,
    onClose: () => {},
    zones: [],
    handleZoneClick: () => {},
}
