import React from 'react';
import PropTypes from 'prop-types';
import { COMPONENTS } from 'common/ui-labels';


export default function DeleteButtons(props) {
    const { submit, close, submitted, disabled, dataId } = props;
    
    return (
        <div className="Form-Buttons">
            <button type="button" data-id={`${dataId}-delete-delete`} onClick={submit} disabled={disabled || submitted}>
                <div className={`${submitted ? 'spinner' : ''}`} style={{ position: 'relative' }}>{COMPONENTS.BUTTONS.DELETE}</div>
            </button>
            <button type="button" data-id={`${dataId}-delete-cancel`} onClick={close} disabled={submitted}>{COMPONENTS.BUTTONS.CANCEL}</button>
        </div>
    );
}

DeleteButtons.propTypes = {
    submit: PropTypes.func,
    close: PropTypes.func,
    submitted: PropTypes.bool,
    disabled: PropTypes.bool,
    dataId: PropTypes.string,
};

DeleteButtons.defaultProps = {
    submit: () => {},
    close: () => {},
    submitted: false,
    disabled: false,
    dataId: '',
};
