import InputRange from 'react-input-range';
import React from 'react';
import PropTypes from 'prop-types';

function InputRangeComponent({ maxValue, minValue, step, units, disabled, input: { onChange, value } }) {
    return (
        <InputRange
            formatLabel={v => `${v}${units}`}
            value={value}
            maxValue={maxValue}
            minValue={minValue}
            step={step}
            disabled={disabled}
            onChange={onChange}
        />
    );
}

InputRangeComponent.propTypes = {
    maxValue: PropTypes.number,
    minValue: PropTypes.number,
    step: PropTypes.number,
    units: PropTypes.string,
    disabled: PropTypes.bool,
    input: PropTypes.shape({
        onChange: PropTypes.func,
        value: PropTypes.string,
    }),
};

InputRangeComponent.defaultProps = {
    maxValue: 0,
    minValue: 0,
    step: 0,
    units: '',
    disabled: false,
    input: {
        onChange: () => {

        },
        value: '',
    },
};

export default InputRangeComponent;
