import React from 'react';
import PropTypes from 'prop-types';

const RenderBox = ({ input, type, id, dataId, dataCy }) => (
    <div>
        <input
            {...input}
            id={id}
            data-id={dataId}
            data-cy={dataCy}
            type={type}
        />
        <label htmlFor={id} />
    </div>
);

RenderBox.propTypes = {
    type: PropTypes.string,
    id: PropTypes.string,
    dataId: PropTypes.string,
    dataCy: PropTypes.string,
    input: PropTypes.shape({}),
};

RenderBox.defaultProps = {
    type: 'text',
    id: '',
    dataId: '',
    dataCy: '',
    input: { },
};
export default RenderBox;
