import React from 'react';
import PropTypes from 'prop-types';

const RenderCheckbox = ({
    input, dataId, name, disabled, title,
}) => (
    <div>
        <input
            {...input}
            type="checkbox"
            onChange={input.onChange}
            name={name}
            checked={input.value}
            value={input.value}
            disabled={disabled}
            id={name}
            style={{ width: '19px', height: '19px' }}
            title={title}
            data-id={dataId}
            className="input"
        />
    </div>
);

RenderCheckbox.propTypes = {
    dataId: PropTypes.string,
    name: PropTypes.string,
    disabled: PropTypes.bool,
    title: PropTypes.string,
    input: PropTypes.shape({}),
};

RenderCheckbox.defaultProps = {
    dataId: '',
    name: '',
    disabled: false,
    title: '',
    input: { },
};

export default RenderCheckbox;
