import React from 'react';

const RenderPositionCoordinatesField = () => ({
    input, label, dataId, type, min, max, step, meta: { touched, error }, disabled,
}) => (
    <div>
        <div className="pull-left"><b>{label}</b></div>
        <div className="position-coordinates-field">
            <input
                {...input}
                min={min}
                max={max}
                step={step}
                type={type}
                disabled={disabled}
                data-id={dataId}
                className="input"
            />
            {touched && error && <span className="error">{error}</span>}
        </div>
    </div>
);


export default RenderPositionCoordinatesField;
