import React from 'react';
import PropTypes from 'prop-types';

function MarkedBlock(props) {
    const { className, label, value, dataCy } = props;

    return (
        <div className={`marked-block ${className}`}>
            {
                label && <span className="marked-block-label">{label}</span>
            }
            <span
                className="marked-block-value"
                data-cy={dataCy}
            >
                {value}
            </span>
        </div>
    );
}

MarkedBlock.propTypes = {
    className: PropTypes.string,
    label: PropTypes.oneOfType([
        PropTypes.string,
        PropTypes.shape({}),
    ]),
    value: PropTypes.string,
    dataCy: PropTypes.string,
};

MarkedBlock.defaultProps = {
    className: '',
    label: '',
    value: '',
    dataCy: '',
};

export default MarkedBlock;
