import _IsEmpty from 'lodash/isEmpty';
import { createSelector } from 'reselect';

const getAdvancedValue = (groupEdit) => {
    const { sensorSpecialCases, user_params } = groupEdit.params;
    const hasSpecialCases = !_IsEmpty(sensorSpecialCases) && Object.values(sensorSpecialCases).find(value => value);

    return !_IsEmpty(user_params.customParams) || hasSpecialCases;
};

export const getGroupEdit = state => state.modals.groupModals.groupEdit;

export const getParseGroupEdit = createSelector(
    [getGroupEdit],
    (groupEdit) => {
        if (groupEdit.params) {
            groupEdit.params.advanced = groupEdit.params.user_params ? getAdvancedValue(groupEdit) : false;
        }
        return groupEdit;
    },
);
