import React from 'react';
import PropTypes from 'prop-types';
import { COMPONENTS } from 'common/ui-labels';
import { Spinner } from 'components/Spinner';

function Buttons(props) {
    const { submit, submitted, invalid, close } = props;

    return (
        <div className="Form-Buttons">
            <button
                type="button"
                data-id="trackable-edit-update-save"
                onClick={() => { submit(); }}
                disabled={invalid || submitted}
            >
                {COMPONENTS.BUTTONS.SAVE}
                <Spinner style={{ marginLeft: '10px' }} show={submitted} />
            </button>
            <button
                type="button"
                data-id="trackable-edit-update-close"
                onClick={close}
                disabled={submitted}
            >
                {COMPONENTS.BUTTONS.CANCEL}
            </button>
        </div>
    );
}

Buttons.propTypes = {
    close: PropTypes.func,
    invalid: PropTypes.bool,
    submit: PropTypes.func,
    submitted: PropTypes.bool,
};

Buttons.defaultProps = {
    close: () => {},
    invalid: true,
    submit: () => {},
    submitted: false,
};

export { Buttons }
