import React, { Fragment } from 'react';
import PropTypes from 'prop-types';

function UserParamsSection(props) {
    if (props.templateProperties.length === 0) { return null; }

    return (
        <Fragment key="trackable-user-params">
            {props.templateProperties.map((item) => (
                <Fragment key={item.name}>
                    <div className="Form-Line row">
                        <div className="Form-Label col-md-4">{item.label}</div>
                        <div
                            className="Form-Value col-md-8"
                            data-id={`trackable-details-${item.name}`}
                            data-cy={`trackable-details-${item.name}`}
                        >
                            {props.user_params[item.name] || ''}
                        </div>
                    </div>
                </Fragment>
            ))}
        </Fragment>
    );
}

UserParamsSection.defaultProps = {
    templateProperties: [],
    user_params: {},
};

UserParamsSection.propTypes = {
    templateProperties: PropTypes.arrayOf(PropTypes.shape({})),
    user_params: PropTypes.shape({}),
};

export { UserParamsSection };
