import React from 'react';
import { Field, FormSection } from 'redux-form';
import PropTypes from 'prop-types';

import 'react-select/dist/react-select.css';

import { renderField } from './trackableModalUtils';

class UserTemplatesSection extends React.Component {
    render() {
        const { templateProperties } = this.props;

        return (
            <FormSection name="user_params">
                {
                    templateProperties.map((property, idx) => (
                        <div key={idx} className="Form-Line row">
                            <Field
                                className="Form-Input"
                                name={property.name}
                                component={renderField}
                                dataId={`trackable-edit-${property.name}`}
                                label={`${property.label}${property.required ? '*' : ''}`}
                                type={property.htmlType}
                            />
                        </div>
                    ))
                }
            </FormSection>
        );
    }
}
UserTemplatesSection.propTypes = {
    templateProperties: PropTypes.arrayOf(PropTypes.shape({})),
};

UserTemplatesSection.defaultProps = {
    templateProperties: [],
};

export { UserTemplatesSection };
