import React from 'react';
import { connect } from 'react-redux';
import { reduxForm } from 'redux-form';
import PropTypes from 'prop-types';

import { NAME_OF_FORMS, ZONE_ADD_MODAL, COMPONENTS } from './../../../common';

let ZoneChooseGeometryForm = (props) => {
    const { close, addRectangle, className, addPolygon } = props;

    return (
        <form className={className}>
            <div className="Form-Confirmation" style={{ marginLeft: '10px' }}>
                {ZONE_ADD_MODAL.FORM_TITLE}
            </div>
            <div className="row" style={{ textAlign: 'center' }}>
                <button
                    type="button"
                    style={{ padding: '20px' }}
                    data-id="zone-add-rectangle"
                    onClick={() => {
                        addRectangle();
                    }}
                >
                    <div className="Rectangle-Shape" />
                    <div style={{ textAlign: 'center' }}>{ZONE_ADD_MODAL.BUTTON_RECTANGLE}</div>
                </button>
                <button
                    type="button"
                    style={{ padding: '20px', width: '180px' }}
                    data-id="zone-add-polygon"
                    onClick={() => {
                        addPolygon();
                    }}
                >
                    <div className="Polygon-Shape" />
                    <div style={{ textAlign: 'center' }}>{ZONE_ADD_MODAL.BUTTON_FREE_FORM}</div>
                </button>
            </div>

            <div className="Form-Buttons">
                <button type="button" data-id="zone-add-cancel" onClick={close}>{COMPONENTS.BUTTONS.CANCEL}</button>
            </div>
        </form>
    );
};

ZoneChooseGeometryForm.propTypes = {
    close: PropTypes.func,
    addRectangle: PropTypes.func,
    addPolygon: PropTypes.func,
    className: PropTypes.string,
};

ZoneChooseGeometryForm.defaultProps = {
    close: () => {
    },
    addRectangle: () => {
    },
    addPolygon: () => {
    },
    className: '',
};

ZoneChooseGeometryForm = reduxForm({
    form: NAME_OF_FORMS.ZONE_ADD,
})(ZoneChooseGeometryForm);

const mapStateToForm = state => ({
    initialValues: state.modals.zoneModals.zoneChooseGeometry,
});

export default ZoneChooseGeometryForm = connect(mapStateToForm)(ZoneChooseGeometryForm);
