import React, { Fragment } from 'react';
import PropTypes from 'prop-types';
import { Field } from 'redux-form';
import RenderBox from 'components/modals/RenderBox';
import { ZONE_CHOOSE_CREATION_MODE } from 'common/ui-labels';

function VerticesControl(props) {
    if (!props.coordinateMode) {
        return (<Fragment />);
    }
    return (
        <div className="Form-Line row">
            <div className="Form-Label col-md-5">
                {ZONE_CHOOSE_CREATION_MODE.COORDINATES}*
            </div>
            <div className="col-md-1 Custom-Rotated-Checkbox" data-id="trackable-edit-advanced">
                <Field
                    name="vertices_options"
                    id="vertices_options"
                    component={RenderBox}
                    type="checkbox"
                />
            </div>
            <div
                className="col-md-7"
            />
        </div>
    );
}

VerticesControl.propTypes = {
    coordinateMode: PropTypes.bool,
};

VerticesControl.defaultProps = {
    coordinateMode: false,
};

export default VerticesControl;
