import React from 'react';
import PropTypes from 'prop-types';

function PageTabs(props) {
    const { tabs, currentPath, navigateToRoute } = props;
    return (
        <div className="Tabs-List">
            {tabs.map((tab, index) => (
                <div
                    key={index}
                    tabIndex={tab.systemName}
                    onClick={() => {
                        navigateToRoute(tab.path);
                    }}
                    className={`List-Elem ${currentPath === tab.path ? 'List-Elem-Selected' : ''}`}
                >
                    {tab.name}
                </div>))
            }
        </div>
    );
}

PageTabs.propTypes = {
    tabs: PropTypes.arrayOf(PropTypes.shape()),
    currentPath: PropTypes.string,
    navigateToRoute: PropTypes.func,
};

PageTabs.defaultProps = {
    tabs: [],
    currentPath: '',
    navigateToRoute: () => {},
};

export default PageTabs;
