import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';

import NodesTableCompanyScope from './tables/NodesTableCompanyScope';
import NodesTableProjectScope from './tables/NodesTableProjectScope';

const NodesTab = ({ isProjectScope }) => (
    <div className="col-md-12">
        {
            isProjectScope && <NodesTableProjectScope />
        }
        {
            !isProjectScope && <NodesTableCompanyScope />
        }
    </div>
);

NodesTab.propTypes = {
    isProjectScope: PropTypes.bool,
};

NodesTab.defaultProps = {
    isProjectScope: false,
};

const mapStateToProps = state => ({
    isProjectScope: !!state.appContext.project,
});

export default connect(mapStateToProps)(NodesTab);
