import { connect } from 'react-redux';
import React, { Fragment } from 'react';
import { USER_ROLES } from 'common';
import TrackablesTable from './tables/TrackablesTable';
import NodesTrackablesTableProjectScope from './tables/NodesTrackablesTableProjectScope';

function TrackablesTagsTab(props) {
    const userRole = (props?.currentUser?.currentRole || props?.currentUser?.access?.currentRole);

    if (userRole === USER_ROLES.PROJECT_MAINTAINER) {
        return (
            <div className="col-md-12 col-lg-12">
                <TrackablesTable
                    isReadOnly
                />
             </div>
        );
    }

    return (
        <Fragment>
            <div className="col-md-12 col-lg-6">
                <TrackablesTable />
            </div>
            <div className="col-md-12 col-lg-6">
                <NodesTrackablesTableProjectScope />
            </div>
        </Fragment>
    );
}

const mapStateToProps = state => ({
    currentUser: state.user,
});

export default connect(mapStateToProps)(TrackablesTagsTab);
