import { ADMIN_TABS_NAME } from 'common/constants';

import withTab from 'components/HOC/withTab';
import CompaniesTab from './CompaniesTab';
import UsersTabSystemScope from './UsersTabSystemScope';
import ProjectsUsersTab from './ProjectsUsersTab';
import NodesTab from './NodesTab';
import NotificationsTab from './NotificationsTab';
import TrackablesTagsTab from './TrackablesTagsTab';
import ShiftsTab from './ShiftsTab';
import GroupsTab from './GroupsTab';
import UsersTabProjectScope from './UsersTabProjectScope';
import ZonesTab from './ZonesTab';
import addons from '../../../js/addons';

const tabs = {
    [ADMIN_TABS_NAME.NOTIFICATIONS]: NotificationsTab,
    [ADMIN_TABS_NAME.COMPANIES]: CompaniesTab,
    [ADMIN_TABS_NAME.SUPER_ADMIN_USERS]: UsersTabSystemScope,
    [ADMIN_TABS_NAME.PROJECTS]: ProjectsUsersTab,
    [ADMIN_TABS_NAME.NODES]: NodesTab,
    [ADMIN_TABS_NAME.TRACKABLE_OBJECTS]: TrackablesTagsTab,
    [ADMIN_TABS_NAME.SHIFTS]: ShiftsTab,
    [ADMIN_TABS_NAME.GROUPS]: GroupsTab,
    [ADMIN_TABS_NAME.USERS_PROJECT_SCOPE]: UsersTabProjectScope,
    [ADMIN_TABS_NAME.ZONES]: ZonesTab,
};

const admin_tabs = { ...tabs, ...addons.tabs };

for (const tab in admin_tabs) {
    if (admin_tabs[tab]) {
        admin_tabs[tab] = withTab(admin_tabs[tab]);
    }
}

export default admin_tabs;
