import React from 'react';
import PropTypes from 'prop-types';

import ShiftInfo from 'pages/dashboard/ShiftInfo';
import MarkedBlock from 'components/uiBlocks/MarkedBlock';
import { COMPONENTS } from 'common/ui-labels';


const PageHeader = (props) => {
    const { activeShift, selectedSiteName, selectedAreaName, timeZone } = props;
    const { SITE, AREA } = COMPONENTS.FIELDS.SITE;

    return (
        <div className="Dashboard-Page-Header">
            <div className="dashboard-site-area-block">

                <MarkedBlock
                    label={SITE}
                    value={selectedSiteName}
                    dataCy="dashboard-site-name"
                />
                <MarkedBlock
                    label={AREA}
                    value={selectedAreaName}
                    dataCy="dashboard-dashboard-area-name"
                />

                <ShiftInfo shift={activeShift} timeZone={timeZone} />
            </div>
        </div>
    );
};

PageHeader.propTypes = {
    selectedSiteName: PropTypes.string,
    selectedAreaName: PropTypes.string,
    activeShift: PropTypes.shape({}),
    timeZone: PropTypes.string,
};

PageHeader.defaultProps = {
    selectedSiteName: '---',
    selectedAreaName: '---',
    activeShift: null,
    timeZone: '',
};

export default PageHeader;
