import React from 'react';
import PropTypes from 'prop-types';
import { getDataForScaling } from 'utils/timeUtils';


export default function AttendanceScale(props) {
    const { start, end, width } = props;
    const { firstIntervalWidth, intervalWidth, lastIntervalWidth, fullHours } = getDataForScaling(start, end, width);
    return (
        <div className="inline-scaling-wrapper">
            { !!firstIntervalWidth && <div className="inline-scaling" style={{ width: firstIntervalWidth }} /> }
            {
                Array(fullHours).fill()
                    .map((el, index) => (<div key={index} className="inline-scaling" style={{ width: intervalWidth }} />))
            }
            { !!lastIntervalWidth && <div className="inline-scaling" style={{ width: lastIntervalWidth }} /> }
        </div>);
}

AttendanceScale.propTypes = {
    start: PropTypes.number,
    end: PropTypes.number,
    width: PropTypes.number,
};

AttendanceScale.defaultProps = {
    start: 0,
    end: 0,
    width: 0,
};
