import { connect } from 'react-redux';
import withReport from 'components/HOC/withReport';
import { getTimeZoneOfProject } from 'utils/timeUtils';
import Alarms from './Alarms';


const AlarmsReport = withReport(Alarms);

const mapStateToProps = state => (
    {
        error: state.reports.alarmsReport.error,
        status: state.reports.alarmsReport.status,
        reportListLoading: state.reports.alarmsReport.reportListLoading,
        reports: state.reports.alarmsReport.reports || [],
        report_uid: state.reports.alarmsReport.uid,
        options: state.reports.alarmsReport.filter,
        timezone: getTimeZoneOfProject(state.appContext.project),
    }
);

export default connect(mapStateToProps)(AlarmsReport);
