import React from 'react';
import PropTypes from 'prop-types';
import { SERVER_REPORT_TYPES, REPORTS_SIDE_BAR, REPORTS_SELECTOR } from 'common';
import ReportsLoader from 'components/ReportsLoader';
import ReportMenu from 'pages/reports/ReportMenu';
import PwsTable from './PwsTable';


function PwsReport(props) {
    return (
        <div className="AppLayout-Selector">
            <ReportMenu
                title={REPORTS_SIDE_BAR.PWS}
                subTitle={REPORTS_SELECTOR.PWS_REPORT_DESCRIPTION}
                type={SERVER_REPORT_TYPES.PWS_REPORT}
                isReady={props.status === 100}
                options={props.options}
                timezone={props.timezone}
            />
            {props.showProgress && <ReportsLoader status={props.status} />}
            {!props.showProgress && <div className="report-content row">
                <div className="col-lg-12 col-md-12">
                    <PwsTable status={props.status} />
                </div>
            </div>}
        </div>
    );
}

PwsReport.propTypes = {
    showProgress: PropTypes.bool,
    status: PropTypes.number,
    timezone: PropTypes.string,
    options: PropTypes.shape({}),
};

PwsReport.defaultProps = {
    showProgress: false,
    status: 0,
    options: null,
    timezone: 'Etx/GMT',
};

export default PwsReport;
