import React, { Component, Fragment } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';

import ZoneCoordinatesEnterModal from 'modals/zone/ZoneCoordinatesEnterModal';

import RightSideBarMessaging from './RightSideBarMessaging';
import RightSideBarTables from './RightSideBarTables';

class RightSideBar extends Component {
    static propTypes = {
        isOpenSideBar: PropTypes.bool,
        zoneTableRowElements: PropTypes.arrayOf(PropTypes.shape()),
    };
    
    static defaultProps = {
        isOpenSideBar: false,
        zoneTableRowElements: [],
    };

    render() {
        if (!this.props.isOpenSideBar) {
            return null;
        }

        const { zoneTableRowElements } = this.props;

        return (
            <div className="RPP-Right-Site-Bar">
                <Fragment>
                    <RightSideBarMessaging />
                    <RightSideBarTables zoneTableRowElements={zoneTableRowElements} />

                    {/* Draggable */}
                    <ZoneCoordinatesEnterModal />
                </Fragment>
            </div>
        );
    }
}

export default connect()(RightSideBar);
