import { SITE_VIEW_MODE } from 'common/ui-labels';
import { SITE_MODE } from 'common/constants';
import PropTypes from 'prop-types';
import React from 'react';

export default function ReturnModeButton(props) {
    const { mode, intl } = props;
    const showReturnButton = mode && mode.name !== SITE_MODE.EDIT_ZONE;
    if (showReturnButton) {
        return (
            <div className="return-to-live-mode">
                <button
                    type="button"
                    className="SiteView-Control-Button btn"
                    onClick={mode.onReturn}
                >
                    {SITE_VIEW_MODE.TITLES.RETURN_FUNC(intl)}
                </button>
            </div>
        );
    }
    return (<div />);
}

ReturnModeButton.propTypes = {
    mode: PropTypes.shape({
        name: PropTypes.string,
        onReturn: PropTypes.func,
    }),
    intl: PropTypes.shape({
        formatMessage: PropTypes.func,
    }),
};

ReturnModeButton.defaultProps = {
    mode: {
        name: '',
        onReturn: () => {},
    },
    intl: {
        formatMessage: () => { },
    },
};
