import React from 'react';
import PropTypes from 'prop-types';
import { SITE_VIEW_UNRESPONSIVE_STATUS_BAR } from 'common/ui-labels';


export default function SiteViewUnresponsiveStatusBar({ hiddenTkoUnresponsiveCount }) {
    if (hiddenTkoUnresponsiveCount === 0) {
        return null;
    }

    return (
        <div className="RPP-SiteViewUnresponsiveStatusBar">
            <span>
                {SITE_VIEW_UNRESPONSIVE_STATUS_BAR.LABEL_FUNC(hiddenTkoUnresponsiveCount)}
            </span>
        </div>
    );
}

SiteViewUnresponsiveStatusBar.propTypes = {
    hiddenTkoUnresponsiveCount: PropTypes.number,
};

SiteViewUnresponsiveStatusBar.defaultProps = {
    hiddenTkoUnresponsiveCount: 0,
};
