import { ACTIONS, STORAGE_KEY } from 'common/constants';
import { setSessionStorageKeyValue, LocationStoreMethods, getSessionStorageValue } from 'utils/browserStorage';

/**
 *
 * @param params
 * @param params.company
 * @param params.company.id
 * @param params.company.name
 * @param params.company.taggings_count
 * @param params.company.user_params
 * @param params.company.user_params.tag_allocation
 * @param params.company.user_params.color
 * @param params.company.user_params.address
 * @param params.company.uid
 * @param params.company.scope
 * @param params.company.role_uid
 * @param params.company.role
 * @param params.company.role.id
 * @param params.company.role.name
 * @param params.company.role.uid
 * @param params.company.role.display_name
 * @param params.company.tag_allocation
 * @param params.company.color
 * @param params.company.address
 * @param params.project
 * @param params.project.uid
 * @param params.project.name
 * @param params.project.priv
 * @param params.project.user_params
 * @param params.project.user_params.timezone
 * @param params.project.user_params.manager
 * @param params.project.settings {object}
 * @param params.project.settings.zone_vertices_limit
 * @param params.project.manager
 * @param params.project.timezone
 * @param params.project.offset
 * @param params.hostName
 * @returns {function}
 */
export const setAppContext = params => (dispatch, getState) => {
    const { user, appContext } = getState();
    const userEmail = user.email || getSessionStorageValue(STORAGE_KEY.USER_EMAIL);
    const projectUid = (appContext.project && appContext.project.uid) || null;
    
    if (params.company) { // update company on storage
        setSessionStorageKeyValue(STORAGE_KEY.CURRENT_COMPANY, JSON.stringify(params.company));
    }

    if (params.project) { // update company on storage
        setSessionStorageKeyValue(STORAGE_KEY.CURRENT_PROJECT, JSON.stringify(params.project));
        LocationStoreMethods.setToLocalStorage(STORAGE_KEY.LAST_PROJECT, params.project, userEmail, projectUid);
    }

    return dispatch({ type: ACTIONS.APP_CONTEXT_SET, params });
};
