import * as api from 'api';
import { ACTIONS } from 'common/constants';
import { errorHandler } from 'stores/actions/errorHandlerActions';

export const loadFloorplans = () => dispatch => new Promise((resolve) => {
    api.getFloorplans()
        .then((floorplans) => {
            dispatch({
                type: ACTIONS.FLOORPLANS_SET,
                params: floorplans,
            });

            resolve();
        })
        .catch((err) => {
            errorHandler(err, dispatch);
            resolve();
        });
});
