import { getTrackablesForPeriod } from 'stores/actions/entityActions/trackablesActions';
import { MODAL_ACTIONS } from 'common/constants';


export const getSiteViewAnalyticsTrackables = params => async (dispatch) => {
    const trackables = await getTrackablesForPeriod(params, dispatch);
    
    dispatch({
        type: MODAL_ACTIONS.AVAILABLE_TRACKABLES,
        params: {
            ...params,
            trackables,
        },
    });
};

export const changePlaybackSelectTrackables = params => ({
    type: MODAL_ACTIONS.PLAYBACK_SELECT_TRACKABLES_CHANGE,
    params,
});

export const siteViewAnalyticsModalUpdateState = params => ({
    type: MODAL_ACTIONS.SITE_ANALYTICS_MODAL_UPDATE_STATE,
    params,
});

export const closeSiteViewAnalyticsModal = () => ({
    type: MODAL_ACTIONS.SITE_ANALYTICS_MODAL_CLOSE,
});

export const siteViewAnalyticsModalTrackablesListLoading = () => ({
    type: MODAL_ACTIONS.SITE_ANALYTICS_TRACKABLES_LOADING,
});

export const siteViewAnalyticsModalChangeSelectedTrackables = params => ({
    type: MODAL_ACTIONS.SITE_ANALYTICS_MODAL_CHANGE_SELECTED_TRACKABLES,
    ...params,
});
