import { MODAL_ACTIONS } from 'common/constants';

export const openWelcomeModal = params => ({
    type: MODAL_ACTIONS.WELCOME_MODAL_OPEN,
    params,
});

export const openProjectsSettingsModal = params => ({
    type: MODAL_ACTIONS.PROJECTS_SETTINGS_MODAL_OPEN,
    params,
});

export const closeProjectsSettingsModal = () => ({
    type: MODAL_ACTIONS.PROJECTS_SETTINGS_MODAL_CLOSE,
});

export const openProjectsSettingsModalBack = () => ({
    type: MODAL_ACTIONS.PROJECTS_SETTINGS_MODAL_BACK_OPEN,
});

export const closeProjectsSettingsModalBack = () => ({
    type: MODAL_ACTIONS.PROJECTS_SETTINGS_MODAL_BACK_CLOSE,
});

export const closeWelcomeModal = () => ({
    type: MODAL_ACTIONS.WELCOME_MODAL_CLOSE,
});

export const openRecommendToChangePassword = params => ({
    type: MODAL_ACTIONS.MODAL_OPEN_RECOMMEND_TO_CHANGE_PASSWORD,
    params,
});

export const closeRecommendToChangePassword = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_RECOMMEND_TO_CHANGE_PASSWORD,
});

export const openEditProfile = params => ({
    type: MODAL_ACTIONS.MODAL_OPEN_EDIT_PROFILE,
    params,
});

export const closeEditProfile = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_EDIT_PROFILE,
});

/**
 *
 * @param params {{ uid, email, token, force }}
 * @returns {{type: null, params: *}}
 */
export const openChangePassword = params => ({
    type: MODAL_ACTIONS.MODAL_OPEN_CHANGE_PASSWORD,
    params,
});

export const closeChangePassword = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_CHANGE_PASSWORD,
});

export const openForgotPassword = () => ({
    type: MODAL_ACTIONS.MODAL_OPEN_FORGOT_PASSWORD,
});

export const changeParamsOfForgotPassword = params => ({
    type: MODAL_ACTIONS.MODAL_CHANGE_FORGOT_PASSWORD,
    params,
});

export const closeForgotPassword = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_FORGOT_PASSWORD,
});

export const cookiesNotEnabledOpen = () => ({
    type: MODAL_ACTIONS.COOKIES_MODAL_OPEN,
});

export const cookiesNotEnabledClose = () => ({
    type: MODAL_ACTIONS.COOKIES_MODAL_CLOSE,
});

// need just for some action go to the middleware (does not handled by any reducers)
export const cookiesNotEnabledTryToClose = () => ({
    type: MODAL_ACTIONS.COOKIES_MODAL_TRY_TO_CLOSE,
});

export const openProjectDeletionPopupModal = () => ({
    type: MODAL_ACTIONS.PROJECT_DELETION_POPUP_MODAL_OPEN,
});

export const closeProjectDeletionPopupModal = () => ({
    type: MODAL_ACTIONS.PROJECT_DELETION_POPUP_MODAL_CLOSE,
});
