import { MODAL_ACTIONS } from 'common/constants';

export const openTrackableDetailsModal = (row) => ({
    type: MODAL_ACTIONS.MODAL_OPEN_TRACKABLE_DETAILS,
    params: row,
});

export const closeTrackableDetailsModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_TRACKABLE_DETAILS,
});

export const openTrackableEditModal = (row) => ({
    type: MODAL_ACTIONS.MODAL_OPEN_TRACKABLE_EDIT,
    params: row,
});

export const openTrackableBulkAssignSimpleModal = (params) => ({
    type: MODAL_ACTIONS.MODAL_OPEN_BULK_TRACKABLE_ASSIGN,
    params,
});

/**
 *
 * @param {Array<Object>} selectedTkos
 * @property {String} params[].uid
 * @property {String} ...
 * @return {(function(*, *): (*))|*}
 */
export const openTrackableBulkAssignModal = (selectedTkos) => (dispatch) => {
    return dispatch(openTrackableBulkAssignSimpleModal(selectedTkos));
};

export const closeTrackableBulkAssignModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_BULK_TRACKABLE_ASSIGN,
});

export const trackableBulkAssignApplyErrorModal = (params) => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_BULK_TRACKABLE_HANDLE_ERROR,
    params,
});

export const bulkAssignUpdateTrackable = (params) => ({
    type: MODAL_ACTIONS.MODAL_BULK_TKO_ASSIGN_UPDATE_TKO,
    params,
});

export const bulkAssignUpdateTag = (params) => ({
    type: MODAL_ACTIONS.MODAL_BULK_TKO_ASSIGN_UPDATE_MAC,
    params,
});

export const bulkAssignAddTrackable = () => ({
    type: MODAL_ACTIONS.MODAL_BULK_TRACKABLE_ASSIGN_ADD_ASSIGN_ITEM,
});

/**
 * @param {number} params
 * @return {{type: null, params}}
 */
export const bulkAssignRemoveTrackable = (params) => ({
    type: MODAL_ACTIONS.MODAL_BULK_TRACKABLE_ASSIGN_REMOVE_ASSIGN_ITEM,
    params,
});

export const closeTrackableEditModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_TRACKABLE_EDIT,
});

export const openTrackableDeleteModal = (row) => ({
    type: MODAL_ACTIONS.MODAL_OPEN_TRACKABLE_DELETE,
    params: row,
});

export const closeTrackableDeleteModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_TRACKABLE_DELETE,
});

export const openTrackableBulkEditModal = (params) => ({
    type: MODAL_ACTIONS.MODAL_OPEN_BULK_TRACKABLE_EDIT,
    params,
});

export const submitTrackableBulkEditModal = (params) => ({
    type: MODAL_ACTIONS.MODAL_BULK_TRACKABLE_EDIT_SUBMITTED,
    params,
});

export const submitTrackableBulkAssignModal = () => ({
    type: MODAL_ACTIONS.MODAL_BULK_TRACKABLE_ASSIGN_SUBMITTED,
});

export const closeTrackableBulkEditModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_BULK_TRACKABLE_EDIT,
});

export const openTrackableBulkEditWarningModal = (params) => ({
    type: MODAL_ACTIONS.MODAL_OPEN_BULK_TRACKABLE_EDIT_WARNING,
    params,
});

export const closeTrackableBulkEditWarningModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_BULK_TRACKABLE_EDIT_WARNING,
});

export const checkboxClick = (params) => (dispatch) => {
    dispatch({
        type: MODAL_ACTIONS.TRACKABLE_CHECKBOX_CLICK,
        params,
    });
};

export const openTrackableCollisionValidationModal = (values, trackable, hasNode, node, groupList) => ({
    type: MODAL_ACTIONS.MODAL_OPEN_LOW_LATENCY_LINK_VALIDATION,
    params: { values, groupList, trackable, hasNode, node },
});

export const closeTrackableCollisionValidationModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_LOW_LATENCY_LINK_VALIDATION,
});

export const showMapClickTrackableEditModal = () => ({
    type: MODAL_ACTIONS.TRACKABLE_STATIONARY_TAG_SHOW_MAP,
});

export const saveStationaryPosition = (params) => ({
    type: MODAL_ACTIONS.MODAL_EDIT_TRACKABLE_SAVE_STATIONARY_POSITION,
    params,
});
