export default class Association {
    constructor(association) {
        this.company_uid = association.company_uid;
        this.created_at = association.created_at || null;
        this.mac_address = association.mac_address || null;
        this.obj_uid = association.obj_uid || null;
        this.project_uid = association.project_uid || null;
        this.removed_at = association.removed_at || null;
        this.trob_uid = association.trob_uid || null;
        this.uid = association.uid || null;
    }
    
    getProperties() {
        return { ...this };
    }
    
    isAssociationObjectUidEqualTo(uid) {
        if ((typeof this.obj_uid === 'string') && (typeof uid === 'string')) {
            return this.obj_uid === uid;
        }
        return undefined;
    }
    
    isAssociationMacAddressUidEqualTo(mac) {
        if ((typeof this.mac_address === 'string') && (typeof mac === 'string')) {
            return this.mac_address.toUpperCase() === mac.toUpperCase();
        }
        return undefined;
    }
    
    static getAllAssociations(state) {
        return state.entities.associations;
    }
}
