export default class Floorplan {
    constructor(floorplan) {
        this.company_uid = floorplan.company_uid;
        this.created_at = floorplan.created_at;
        this.display_name = floorplan.display_name || 0;
        this.height = floorplan.height || 0;
        this.image_offset_x = floorplan.image_offset_x || 0;
        this.image_offset_y = floorplan.image_offset_y || 0;
        this.image_rotation = floorplan.image_rotation || 0;
        this.image_scale = floorplan.image_scale || null;
        this.img_blob = floorplan.img_blob || null;
        this.project_uid = floorplan.project_uid;
        this.selected = floorplan.selected || 0;
        this.size = floorplan.size || 0;
        this.sublocation_id = floorplan.sublocation_id || null;
        this.sublocation_uid = floorplan.sublocation_uid || null;
        this.uid = floorplan.uid;
        this.updated_at = floorplan.updated_at;
        this.url = floorplan.url || 0;
        this.width = floorplan.width || 0;
    }
    
    getProperties() {
        return { ...this };
    }
    
    isFloorplanUidEqualTo(uid) {
        if ((typeof this.uid === 'string') && (typeof uid === 'string')) {
            return this.uid === uid;
        }
        return undefined;
    }
    
    static getAllFloorplans(state) {
        return state.entities.floorplans;
    }
}
