import intersects from 'intersects';

export default class Polygon {
    constructor(points = []) {
        this.points = points;
        this.size = points.length;
    }

    get _lines() {
        const lines = [];
        for (let i = 0; i < this.size; i += 1) {
            const a = this.points[i];
            const b = i === this.size - 1 ? this.points[0] : this.points[i + 1];
            lines.push([a, b]);
        }
        const lastPoint = this.points[this.points.length - 1];
        const firstPoint = this.points[0];
        lines.push([lastPoint, firstPoint]);
        return lines;
    }

    get selfIntersects() {
        let result = false;
        for (let i = 0; i < this.size - 1; i += 1) {
            const limitShift = i ? 0 : 1; // exclude last line comparison for the first one because they are neighbours
            for (let j = i + 2; j < this.size - limitShift; j += 1) {
                const intersect = intersects.lineLine(
                    this._lines[i][0].x, this._lines[i][0].y,
                    this._lines[i][1].x, this._lines[i][1].y,
                    this._lines[j][0].x, this._lines[j][0].y,
                    this._lines[j][1].x, this._lines[j][1].y,
                );

                if (intersect) {
                    result = true;
                }
            }
        }
        return result;
    }
}
