export default class Project {
    constructor(project) {
        this.uid = project.uid;
        this.name = project.name || '';
        this.priv = project.projects || [];
        this.user_params = project.user_params || {};
        this.settings = project.settings || null;
    }
    
    getProperties() {
        return { ...this };
    }
    
    getFormattedProject() {
        const formattedProject = { ...this };
    
        formattedProject.manager = this.user_params.manager ? this.user_params.manager : '';
        formattedProject.timezone = this.user_params.timezone ? this.user_params.timezone : '';
        formattedProject.offset = this.user_params.offset ? this.user_params.offset : 0;
        
        return formattedProject;
    }
}
