export default class Sublocation {
    constructor(sublocation) {
        this.company_uid = sublocation.company_uid;
        this.created_at = sublocation.created_at;
        this.description = sublocation.description || null;
        this.location_uid = sublocation.location_uid || null;
        this.name = sublocation.name;
        this.offset_x = sublocation.offset_x || 0;
        this.offset_y = sublocation.offset_y || 0;
        this.offset_z = sublocation.offset_z || 0;
        this.project_name = sublocation.project_name || null;
        this.project_uid = sublocation.project_uid;
        this.uid = sublocation.uid;
        this.updated_at = sublocation.updated_at;
        this.id = sublocation.id || null;
    }
    
    getProperties() {
        return { ...this };
    }
    
    isSublocationUidEqualTo(uid) {
        if ((typeof this.uid === 'string') && (typeof uid === 'string')) {
            return this.uid === uid;
        }
        return undefined;
    }
    
    static getAllSublocations(state) {
        return state.entities.sublocations;
    }
}
