export default class WinAnchor {
    constructor(win) {
        this.acc_config = win.acc_config || null;
        this.bt_config = win.bt_config || null;
        this.company_uid = win.company_uid || null;
        this.created_at = win.created_at || null;
        this.locked = win.locked || false;
        this.name = win.name || null;
        this.node = win.node || null;
        this.battery = win.battery || null;
        this.last_heard = win.last_heard || null;
        this.position = win.position || null;
        this.project_uid = win.project_uid || null;
        this.shm_status = win.shm_status || null;
        this.state = win.state || null;
        this.sublocation_uid = win.sublocation_uid || null;
        this.type = win.type || null;
        this.uid = win.uid || null;
        this.updated_at = win.updated_at || null;
    }
    
    getProperties() {
        return { ...this };
    }

    /**
     *
     * @param state
     * @returns {object<WinAnchor>}
     */
    static getAllWinAnchors(state) {
        return state.entities.winAnchors.byUid;
    }
    /**
     *
     * @param state
     * @returns {array<WinAnchor>}
     */
    static getAllWinAnchorsArray(state) {
        return Object.values(WinAnchor.getAllWinAnchors(state));
    }
}
