import { ACTIONS } from 'common/constants';

const initialState = {
    widgets: [],
    alarms: {
        data: null,
        error: null,
        loading: false,
        updatedAt: '', // ISO 8601
    },
};

const dashboard = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.RELOAD_CONTEXT: {
            const { widgets } = action.params;
            return {
                ...state,
                widgets,
            };
        }
        case ACTIONS.DASHBOARD_CHANGE_WIDGETS: {
            return {
                ...state,
                widgets: action.params.newWidgets,
            };
        }

        case ACTIONS.DASHBOARD_ALARMS_SET: {
            return {
                ...state,
                alarms: {
                    updatedAt: new Date().toISOString(),
                    data: action.params,
                    error: null,
                    loading: false,
                },
            };
        }

        case ACTIONS.DASHBOARD_ALARMS_LOADING: {
            return {
                ...state,
                alarms: {
                    ...state.alarms,
                    loading: true,
                },
            };
        }

        case ACTIONS.DASHBOARD_ALARMS_ERROR: {
            return {
                ...state,
                alarms: {
                    ...state.alarms,
                    loading: false,
                    error: action.params,
                },
            };
        }

        default:
            return state;
    }
};

export default dashboard;
