import { combineReducers } from 'redux';

import alarms from './alarms';
import associations from './associations';
import companies from './companies';
import entitiesLoaded from './entitiesLoaded';
import floorplans from './floorplans';
import groups from './groups';
import locations from './locations';
import messages from './messages';
import nodes from './nodes';
import notifications from './notifications';
import notificationTypes from './notificationTypes';
import projects from './projects';
import sublocations from './sublocations';
import subscribers from './subscribers';
import systemSubscribers from './systemSubscribers';
import trackables from './trackables';
import trackableTemplates from './trackableTemplates';
import users from './users';
import usersAccessControl from './usersAccessControl';
import winAnchors from './winAnchors';
import zones from './zones';
import zonesPrototypes from './zonesPrototypes';

const entities = combineReducers({
    alarms,
    associations,
    companies,
    entitiesLoaded,
    floorplans,
    groups,
    locations,
    messages,
    nodes,
    notifications,
    notificationTypes,
    projects,
    sublocations,
    subscribers,
    systemSubscribers,
    trackables,
    trackableTemplates,
    users,
    usersAccessControl,
    winAnchors,
    zones,
    zonesPrototypes,
});

export default entities;
