import { NOTIFY_ACTIONS } from 'worker';
import { ACTIONS } from 'common/constants';

/**
 * @typedef subscriber {Array}
 * @params uid {string}
 * @params name {string}
 * @params notification {Array<string>} Notification uid list
 * @params email {string}
 * @params phone {string}
 */
const initialState = [];

const systemSubscribers = (state = initialState, action) => {
    const newState = [];
    
    switch (action.type) {
        case ACTIONS.SYSTEM_SUBSCRIBERS_SET:
            return [...action.params];
        
        case NOTIFY_ACTIONS.SHM_SUBSCRIPTION_UPDATED:
        case ACTIONS.SHM_SUBSCRIPTION_UPDATE: {
            let isUpdate = false;
            state.forEach((systemSubscriber) => {
                if (systemSubscriber.user_uid === action.params.user_uid) {
                    newState.push(action.params);
                    isUpdate = true;
                } else {
                    newState.push(systemSubscriber);
                }
            });
            if (!isUpdate) {
                newState.push(action.params);
            }
            return newState;
        }
        default:
            return state;
    }
};

export default systemSubscribers;
