import { ACTIONS } from 'common/constants';


const initialState = {
    completedHeatmaps: [],
    currentHeatmaps: [],
    isHeatmapLoading: false,
};

const heatmap = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.RELOAD_CONTEXT:
            return {
                ...state,
                completedHeatmaps: action.params.completedHeatmaps || initialState.completedHeatmaps,
            };
        case ACTIONS.HEATMAP_REQUEST_SEND:
            return {
                ...state,
                isHeatmapLoading: true,
            };
        case ACTIONS.HEATMAP_REQUEST_RECEIVE:
            return {
                ...state,
                isHeatmapLoading: false,
            };
        case ACTIONS.HEATMAP_CHANGE_PARAMS:
            return {
                ...state,
                ...action.params,
            };
        case ACTIONS.HEATMAP_CLEAR:
            return {
                ...state,
                currentHeatmaps: initialState.currentHeatmaps,
            };
        default:
            return state;
    }
};

export default heatmap;
