import { MODAL_ACTIONS } from '../../../../common/constants';

const initialState = {
    open: false,
};

const userEdit = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.MODAL_OPEN_USER_EDIT:
            return {
                ...state,
                open: true,
                params: {
                    ...action.params,
                    send_notification: true, // default checked
                },
            };
        case MODAL_ACTIONS.MODAL_CLOSE_USER_EDIT:
            return {
                ...initialState,
            };
        case MODAL_ACTIONS.MODAL_OPEN_USER_EDIT_SYSTEM_SCOPE:
            return {
                ...state,
                openSystemScope: true,
                params: {
                    ...action.params,
                    send_notification: true, // default checked
                },
            };
        case MODAL_ACTIONS.MODAL_CLOSE_USER_EDIT_SYSTEM_SCOPE:
            return {
                ...initialState,
            };
        case MODAL_ACTIONS.MODAL_SEND_NOTIFICATION_USER_EDIT:
            return {
                ...state,
                sendNotification: true,
            };
        case MODAL_ACTIONS.MODAL_GET_NOTIFICATION_USER_EDIT:
            return {
                ...state,
                sendNotification: false,
            };
        default:
            return state;
    }
};

export default userEdit;
