import { MODAL_ACTIONS, ZONE_APPLY_TO, ZONE_MODE } from 'common/constants';


const initialState = {
    open: false,
    rotation: 0,
    user_params: {
        direction: 0,
    },
    width: 2,
    sublocation_uid: null,
    location_uid: null,
    floorplan_uid: null,
    zone_mode: ZONE_MODE.ALWAYS_ACTIVE,
    activated: false,
    active24: true,
    default_allowed: false,
    trackable_exceptions: [],
    group_exceptions: [],
    advanced_options: false,
    vertices_options: true,
    coordinateMode: false,
    geometry: {
        zoneGeometryInDegrees: [],
        zoneGeometryInMillimeters: [],
        vertices: {},
    },
    zone_alarm_level: 1,
    apply_to: ZONE_APPLY_TO.ALL,
    toHour: '24',
    toMinute: '00',
    fromHour: '00',
    fromMinute: '00',
};

const zoneCreateAdminPage = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.MODAL_OPEN_ZONE_CREATE_ADMIN_PAGE:
            return {
                ...state,
                width: action.params || state.width,
                open: true,
            };
        case MODAL_ACTIONS.MODAL_CHOOSE_AREA_ZONE_CREATE_ADMIN_PAGE:
            return {
                ...state,
                sublocation_uid: action.params.sublocation_uid,
                location_uid: action.params.location_uid,
            };
        case MODAL_ACTIONS.MODAL_CHOOSE_TYPE_ZONE_CREATE_ADMIN_PAGE:
            return {
                ...state,
                zone_type_name: action.params.zone_type_name,
            };
        case MODAL_ACTIONS.MODAL_SELECT_FLOORPLAN_CREATE_ADMIN_PAGE:
            return {
                ...state,
                floorplan_uid: action.params,
            };
        case MODAL_ACTIONS.MODAL_SAVE_OPTIONS_ZONE_CREATE_ADMIN_PAGE:
            return {
                ...state,
                ...action.params,
            };
        case MODAL_ACTIONS.MODAL_SET_ZONE_CREATE_ADMIN_PAGE:
            return {
                ...action.params,
            };
        case MODAL_ACTIONS.MODAL_UNSELECT_FLOORPLAN_CREATE_ADMIN_PAGE:
            return {
                ...state,
                floorplan_uid: null,
            };
        case MODAL_ACTIONS.MODAL_CLOSE_ZONE_CREATE_ADMIN_PAGE:
            return {
                ...initialState,
                user_params: {
                    direction: 0,
                },
            };
        case MODAL_ACTIONS.MODAL_SET_COORDINATES_REGIME_CREATE_ADMIN_PAGE:
            return {
                ...state,
                coordinateMode: true,
            };
        case MODAL_ACTIONS.MODAL_CLEAR_COORDINATES_REGIME_CREATE_ADMIN_PAGE:
            return {
                ...state,
                coordinateMode: false,
            };
        case MODAL_ACTIONS.MODAL_CLEAR_GEOMETRY_ZONE_CREATE_ADMIN_PAGE: {
            return {
                ...state,
                geometry: { ...initialState.geometry },
            };
        }
        case MODAL_ACTIONS.MODAL_REMOVE_VERTEX_ZONE_CREATE_ADMIN_PAGE: {
            const newState = { ...state, geometry: { ...state.geometry, vertices: { ...state.geometry.vertices } } };
            delete newState.geometry.vertices[action.params];
            return newState;
        }
        case MODAL_ACTIONS.MODAL_ADD_VERTEX_ZONE_CREATE_ADMIN_PAGE: {
            const newState = { ...state, geometry: { ...state.geometry, vertices: { ...state.geometry.vertices } } };
            newState.geometry.vertices[action.params.index] = action.params;
            return newState;
        }
        default:
            return state;
    }
};

export default zoneCreateAdminPage;
