import { ACTIONS } from 'common/constants';

const initialState = {
    status: 0,
    error: null,
    tableData: [],
    options: null,
    report: null,
    reportLoading: false,
    filter: {
        isLoading: false,
        advancedSelected: true,
        periodTrackables: null,
    },
};

const pwsReport = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.SET_PWS_REPORT: {
            const status = action.params.status ? action.params.status : state.status;
            return {
                ...state,
                status,
            };
        }
        case ACTIONS.CLEAR_PWS_REPORT:
            return {
                ...initialState,
                filter: {
                    ...state.filter,
                },
            };
        case ACTIONS.SET_PWS_REPORT_FILTER_TRACKABLES:
            return {
                ...state,
                reportLoading: false,
                filter: {
                    ...state.filter,
                    periodTrackables: action.params,
                },
            };
        case ACTIONS.SET_PWS_REPORT_LOADING_TRACKABLES:
            return {
                ...state,
                reportLoading: true,
                filter: {
                    ...state.filter,
                    periodTrackables: null,
                },
            };
        case ACTIONS.SET_PWS_TABLE_DATA:
            return {
                ...state,
                status: 100,
                ...action.params,
            };
        case ACTIONS.SET_PWS_REPORT_ERROR: {
            return {
                ...state,
                reportLoading: false,
                error: action.params,
            };
        }
        case ACTIONS.ADVANCED_SELECT_PWS_REPORT:
        case ACTIONS.TIME_SELECT_PWS_REPORT: {
            return {
                ...state,
                filter: {
                    ...state.filter,
                    ...action.params,
                },
            };
        }
        default:
            return state;
    }
};

export default pwsReport;
