import { ACTIONS } from 'common/constants';


const initialState = {
    active: false,
    error: {
        message: '',
        invalid: true,
        geometryIntersects: false,
    },
    vertices: {},
};

const siteViewZoneEditCoordinates = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.ZONE_EDIT_COORDINATES_MODE_ACTIVE:
            return {
                ...state,
                active: true,
            };
        case ACTIONS.ZONE_EDIT_COORDINATES_MODE_INACTIVE:
            return {
                ...state,
                ...initialState,
            };
        case ACTIONS.ZONE_EDIT_COORDINATES_ADD_VERTEX: {
            const newState = { ...state, vertices: { ...state.vertices } };
            newState.vertices[action.params.index] = action.params;
            return newState;
        }
        case ACTIONS.ZONE_EDIT_COORDINATES_SET_ERROR: {
            return {
                ...state,
                error: action.params,
            };
        }
        case ACTIONS.ZONE_EDIT_COORDINATES_REMOVE_VERTEX: {
            const newState = { ...state, vertices: { ...state.vertices } };
            delete newState.vertices[action.params];
            return newState;
        }
        default:
            return state;
    }
};

export default siteViewZoneEditCoordinates;
