import { fork, takeEvery, call, put } from 'redux-saga/effects';
import * as api from 'api';

import { ACTIONS, SAGA_ACTIONS } from 'common/constants';
import { formatGroup } from 'common/formatters/groupFormatters';
import errorHandler from '../commonSaga';


export function* createGroup(action) {
    try {
        const { group } = yield call(formatGroup, action.params);
        const _group = yield call(api.createGroup, group);
        yield put({ type: ACTIONS.GROUP_CREATE, params: _group });
    } catch (err) {
        yield call(errorHandler, err);
    }
}

function* watchCreateGroup() {
    yield takeEvery(SAGA_ACTIONS.SAGA_GROUPS_CREATE, createGroup);
}

export default function* groupCreateSaga() {
    return yield fork(watchCreateGroup);
}
