import { all, fork, call, put, takeEvery } from 'redux-saga/effects';

import { closeZoneDeleteModal } from 'stores/actions/modalActions/zoneModalActions';
import { deleteStaticDynamicZone } from 'stores/sagas/zone/zoneSagas';
import { SAGA_ACTIONS } from 'common/constants';
import errorHandler from 'stores/sagas/commonSaga';

function* deleteZones(action) {
    try {
        if (action.params.uid) {
            yield call(deleteStaticDynamicZone, { uid: action.params.uid });
        } else {
            for (let i = 0; i < action.params.length; i += 1) {
                yield call(deleteStaticDynamicZone, { uid: action.params[i].uid });
            }
        }
        yield put(closeZoneDeleteModal());
    } catch (err) {
        yield call(errorHandler, err);
    }
}


function* watchDeleteZone() {
    yield takeEvery(SAGA_ACTIONS.SAGA_ZONES_DELETE, deleteZones);
}

export default function* zoneDeleteSaga() {
    return yield all([
        fork(watchDeleteZone),
    ]);
}
