export function addModulesPageForUser(access, pages, modules) {
    modules.forEach((module) => {
        const userHasAccess = Array.isArray(module.user_role) && module.user_role.indexOf(access) !== -1;
        const routeExist = (module.route && module.route.to) ? pages.find(page => page.path === module.route.to) : false;
        
        if (userHasAccess && module.route && !routeExist) {
            pages.push({
                path: module.route.to,
            });
        }
        if (userHasAccess && module.tabs) {
            pages.forEach((page) => {
                if (page.path === module.tabs.page) {
                    page.tabs = [...page.tabs, module.tabs];
                }
            });
        }
    });
    return pages;
}

export function addModulesNavForUser(access, navButtons, modules) {
    modules.forEach((module) => {
        const routeExist = (module.route && module.route.to) ? navButtons.find(but => but.to === module.route.to) : false;
        if (Array.isArray(module.user_role) && module.user_role.indexOf(access) !== -1 && module.route && !routeExist) {
            navButtons.push(module.route);
        }
    });
    return navButtons;
}
