import axios from 'axios';

export function loadTrackableAssociations() {
    return axios.get('/api/v2/trackable_objects_associations/').then(({ data }) => data.trackable_objects_associations || data);
}

export function createTrackableAssociations(association) {
    return axios.post('/api/v2/trackable_objects_associations/', association)
        .then(({ data }) => data.association || data)
        .catch(() => null);
}

export function closeTrackableAssociations(association) {
    return axios.put('/api/v2/trackable_objects_associations/close', association)
        .then(({ data }) => data.association || data);
}

export function getActiveTrackObjectAssociationsForInterval(start, end) {
    return axios.get(`/api/v2/track_assoc?start=${start}&end=${end}`).then(({ data }) => data.trackable_objects_associations || data);
}
