import axios from 'axios';

export function createCompany({
    name, color, phone, website, address, tag_allocation, uid, email, password,
}) {
    const params = {
        company: {
            name,
            user_params: {
                color,
                phone,
                website,
                tag_allocation,
                address,
            },
            uid,
        },
        user: {
            email,
            password,
        },
    };
    return axios.post('/api/v2/companies/', params).then(res => res.data);
}

export function getCompanies() {
    return axios.get('/api/v2/companies/').then(res => res.data.companies);
}

export function deleteCompany(company_uid) {
    return axios.delete(`/api/v2/companies/${company_uid}`).then(res => res.data);
}

export function updateCompany({
    name, color, phone, website, labels, address, uid, tag_allocation,
}) {
    const params = {
        company: {
            name,
            user_params: {
                color,
                phone,
                website,
                labels,
                tag_allocation,
                address,
            },
        },
    };
    return axios.put(`/api/v2/companies/${uid}`, params).then(res => res.data.company);
}
