import axios from 'axios';

export function getLocations() {
    return axios.get('/api/v2/locations/').then(({ data }) => data.locations || data);
}

export function getLocationShiftActivities(uid) {
    return axios.get(`/api/v2/locations/shift_activities/${uid}`)
        .then(({ data }) => data.activities || data);
}

export function updateLocation(params) {
    const { uid, shift, name } = params;
    
    return axios.put(`/api/v2/locations/${uid}`, { name, shift }).then(res => res.data);
}
