import axios from 'axios';

const FileDownload = require('js-file-download');

export function downloadAudit(options) {
    return axios.get(`/api/v2/audit?from=${options ? options.from : false}&to=${options ? options.to : false}&company_uid=${options ? options.company_uid : false}`)
        .then((response) => {
            FileDownload(response.data, response.headers['response-filename'] || 'audit.csv');
        });
}

export function getLoggerAction(options) {
    return axios.get(`/api/v2/logger/actions?from=${options ? options.from : false}&to=${options ? options.to : false}`);
}

export function getLoggerFileContent(date) {
    return axios.get(`/api/v2/logger/logs?date=${date}`);
}

export function getMessageProcessorState() {
    return axios.get('/api/v2/logger/message_processor');
}

export function getServerLoggerState() {
    return axios.get('/api/v2/logger/');
}

export function postServerLoggerState(key, value) {
    return axios.post('/api/v2/logger/', { [key]: value });
}

export function deleteServerLoggerState() {
    return axios.delete('/api/v2/logger/');
}
