import axios from 'axios';

export async function getNodes() {
    const nodes = await axios.get('/api/v2/nodes');
    return nodes.data.nodes || nodes.data || [];
}

export async function createNode(params) {
    try {
        const nodes = await axios.post('/api/v2/nodes/', params);
        return nodes.data;
    } catch (err) {
        console.error('ERROR IN AXIOS', err);
        throw err;
    }
}

export async function assignNode(params) {
    const node = await axios.post('/api/v2/nodes_associations/assign', params);
    return node.data;
}

export async function releaseNode(params) {
    const node = await axios.post('/api/v2/nodes_associations/release', params);
    return node.data;
}

export async function deleteNode(uid) {
    await axios.delete(`/api/v2/nodes/${uid}`);
    return { uid };
}

export async function validateNodes(data) {
    const validation = await axios.post('/api/v2/nodes/validate/', data);
    return validation.data;
}