import axios from 'axios';

export function getNotifications() {
    return axios.get('/api/v2/notifications/').then(({ data }) => data.notifications || data);
}

export function getNotificationTypesList() {
    return axios.get('/api/v2/notification_types').then(({ data }) => data.notification_types || data);
}

export function createNotification(params) {
    return axios.post('/api/v2/notifications/', params).then(res => res.data);
}

export function updateNotification(params) {
    const { uid } = params;
    return axios.put(`/api/v2/notifications/${uid}`, params).then(res => res.data);
}

export function deleteNotification(params) {
    return axios.delete(`/api/v2/notifications/${params.uid}`).then(res => res.data);
}
