import axios from 'axios';

const FileDownload = require('js-file-download');

export function getReportsList({ location_uid, from, to }, type) {
    return axios.get(`/api/v2/report?from=${from}&to=${to}&site_uid=${location_uid}&type=${type}`).then((res) => res.data);
}

export function getReportData(uid, isOutputFile) {
    return axios.get(`/api/v2/report/${uid}?file=${isOutputFile}`).then((res) => res.data);
}

export function getPwsData({ trackable_uid, from, to, page, limit }) {
    const url = `/api/v2/external_events?event_type[]=pws&from=${from}&to=${to}&track_uid[]=${trackable_uid}&page=${page}&limit=${limit}`;
    return axios.get(url).then((res) => res.data);
}

export function downloadPws(url) {
    return axios.get(url, { responseType: 'blob' })
        .then((response) => {
            FileDownload(response.data, response.headers['response-filename'] || 'pws_report.zip');
        });
}

export function createHeatmap(params) {
    const data = { type: 'heatmap_report', ...params };
    return axios.post('/api/v2/obsolete/report', data).then((res) => res.data);
}

export function getHeatmapUrl(hostName, uid, search) {
    return `${hostName}/api/v2/heatmap/${uid}${search}`;
}

export function getReport(uid, callback) {
    return axios.get(`/api/v2/obsolete/report/${uid}`).then((res) => res.data)
        .catch((err) => {
            callback(null, err);
            throw err;
        });
}
