import { NEAR_MISS_WORKER_METHODS } from './common/constants';
import NearMissEventHandler from './NearMissEventHandler';

let nearMissEvent;

self.addEventListener('message', (message) => {
    const { method, params } = message.data;

    switch (method) {
        case NEAR_MISS_WORKER_METHODS.INIT_NEAR_MISS: {
            nearMissEvent = new NearMissEventHandler(params);
            break;
        }
        case NEAR_MISS_WORKER_METHODS.GENERATE_NEAR_MISS: {
            if (nearMissEvent) {
                nearMissEvent.generateNearMiss(params);
            } else {
                nearMissEvent = new NearMissEventHandler(params);
                nearMissEvent.generateNearMiss(params);
            }
            break;
        }
        case NEAR_MISS_WORKER_METHODS.STOP_NEAR_MISS: {
            if (nearMissEvent) {
                nearMissEvent.terminate();
                nearMissEvent = undefined;
            } else {
                console.warn('Spaghetti worker already terminated');
            }
            break;
        }
        case NEAR_MISS_WORKER_METHODS.GET_NEAR_MISS_DATA: {
            nearMissEvent.getDataForTimeFrame(params);
            break;
        }
        default: {
            console.info(`No handler for method: "${method}" in nearMissEvent worker`);
        }
    }
});
