import { WS_ACTIONS } from 'worker/common/constants';


export default class PlaybackNotifyRequestMethods {
    _sendDataToClient = (positions, alarms) => {
        self.postMessage({
            type: WS_ACTIONS.PLAYBACK_POSITIONS,
            params: [...positions],
        });
        
        self.postMessage({
            type: WS_ACTIONS.PLAYBACK_ALARMS,
            params: [...alarms],
        });
    };
    
    _rejectPlayback = () => {
        self.postMessage({
            type: WS_ACTIONS.PLAYBACK_ERROR,
            params: {
                message: 'Data is not available now',
                title: 'Error generating Playback',
            },
        });
    }
    
    _sendInitialPositionsToClient = (initialPositions) => {
        self.postMessage({
            type: WS_ACTIONS.PLAYBACK_INITIAL_POSITIONS,
            params: [...initialPositions],
        });
    };
    
    _changeClientPlaybackParams = (params) => {
        self.postMessage({
            type: WS_ACTIONS.PLAYBACK_CHANGE_PARAMS,
            params,
        });
    };
    
    _notifyClientAboutPending = () => {
        self.postMessage({
            type: WS_ACTIONS.PLAYBACK_PENDING_REQUEST,
        });
    };
    
    _notifyClientAboutReadyState = () => {
        self.postMessage({
            type: WS_ACTIONS.PLAYBACK_RECEIVED_REQUEST,
        });
    };
}
