import axios from 'axios';

export function getPlaybackAlarms(params) {
    const { from, to, trackables, sublocation_uid, target_server } = params;
    const queryServer = target_server ? `target_server=${target_server}` : '';
    const queryTrackables = trackables.map((tko) => `obj_uid[]=${tko}&`).join('');
    return axios.get(`/api/v2/alarms?${queryTrackables}from=${new Date(from).getTime()}&to=${new Date(to).getTime()
    }&format=json&sublocation_uid=${sublocation_uid
    }&alarm_type_name[]=zone_violation&alarm_type_name[]=buffer_violation&alarm_type_name[]=emergency_button&alarm_type_name[]=uncertified_operation&${queryServer}`)
        .then(({ data }) => data.alarms || data);
}

export function getInitialPos(params) {
    const { from, trackables, area_uid, target_server } = params;
    const queryServer = target_server ? `target_server=${target_server}` : '';
    const queryTrackables = trackables.map((tko) => `track_uid[]=${tko}&`).join('');
    return axios.get(`/api/v2/data/positions/initial?${queryTrackables}from=${new Date(from).toISOString()}&area_uid=${area_uid}&${queryServer}`)
        .then(({ data }) => data.positions || data);
}

export function getPos(params) {
    const { from, to, trackables, area_uid, target_server } = params;
    const queryServer = target_server ? `target_server=${target_server}` : '';
    const queryTrackables = trackables.map((tko) => `track_uid[]=${tko}&`).join('');
    return axios.get(`/api/v2/data/positions?${queryTrackables}from=${new Date(from).toISOString()}&to=${new Date(to).toISOString()}&area_uid=${area_uid}&${queryServer}`)
        .then(({ data }) => data.positions || data);
}
