import { WORKER_METHODS } from 'worker/common/constants';
import PlaybackHandlers from './PlaybackHandlers';

let playback;

self.addEventListener('message', (message) => {
    const { method, params } = message.data;
    
    switch (method) {
        case WORKER_METHODS.PLAYBACK_INIT: {
            playback = new PlaybackHandlers(params);
            break;
        }
        case WORKER_METHODS.PLAYBACK_GENERATE: {
            playback.generatePlayback(params.setting);
            break;
        }
        case WORKER_METHODS.PLAYBACK_CLEAR: {
            playback.clearHistory();
            break;
        }
        case WORKER_METHODS.PLAYBACK_GET_DATA: {
            const key = params.ts;
            playback.requestDataFromPlaybackStore(key);
            break;
        }
        default: {
        }
    }
});
