import { getUID } from 'worker/utils';


export function formatPos(pos) {
    const timestamp = new Date(pos.ts);
    const mills = timestamp.getTime();
    const ms = mills % 1000;
    const ts = Math.floor(mills / 1000);
    
    return {
        dev_id: pos.trackable_uid,
        sl_id: pos.area_uid,
        project_uid: pos.project_uid,
        mac_address: pos.mac_address,
        x: pos.x,
        y: pos.y,
        z: pos.z,
        ts,
        ms,
    };
}

export function formatAlarm(alarm) {
    const uid = `${alarm.zone_uid ? alarm.zone_uid : 'NZ'}_${alarm.obj_id}_${alarm.created_at}_${alarm.alarm_type_id}`;
    return {
        created_at: alarm.created_at,
        updated_at: alarm.updated_at,
        additional_info: alarm.additional_info,
        alarm_type_id: alarm.alarm_type_id,
        alarm_name: alarm.alarm_name,
        state: alarm.state,
        obj_uid: alarm.obj_id,
        uid,
        zone_uid: alarm.zone_uid,
        ts: alarm.created_at,
        x: alarm.x,
        y: alarm.y,
        z: alarm.z,
    };
}
