import { WORKER_METHODS } from 'worker/common/constants';
import SpaghettiHandler from './SpaghettiHandler';

let spaghetti;

self.addEventListener('message', (message) => {
    const { method, params } = message.data;

    switch (method) {
        case WORKER_METHODS.SPAGHETTI_INIT: {
            spaghetti = new SpaghettiHandler(params);
            break;
        }
        case WORKER_METHODS.SPAGHETTI_GENERATE: {
            if (spaghetti) {
                spaghetti.generateSpaghetti(params);
            } else {
                spaghetti = new SpaghettiHandler(params);
                spaghetti.generateSpaghetti(params);
            }
            break;
        }
        case WORKER_METHODS.SPAGHETTI_STOP: {
            if (spaghetti) {
                spaghetti.terminate();
                spaghetti = undefined;
            } else {
                console.warn('Spaghetti worker already terminated');
            }
            break;
        }
        case WORKER_METHODS.GET_SPAGHETTI_DATA: {
            spaghetti.requestSpaghettiFromWorker(params);
            break;
        }
        default: {
        }
    }
});
