import KeyMirror from 'keymirror';

export const WORKER_METHODS = KeyMirror({
    SPAGHETTI_INIT: null,
    SPAGHETTI_GENERATE: null,
    SPAGHETTI_STOP: null,
    GET_SPAGHETTI_DATA: null,
    SPAGHETTI_POSITIONS: null,
    SPAGHETTI_ERROR: null,
    SPAGHETTI_IS_READY: null,
    SET_SPAGHETTI_ID: null,
    
    INIT: null,
    UPDATE_CONNECTION: null,
    STOP: null,

    CLIENT_RECEIVED_POS: null,

    UNSUBSCRIBE_ALL: null,
    SUBSCRIBE_ALL: null,
    UNSUBSCRIBE: null,
    SUBSCRIBE: null,
    TURN_OFF_LIVE_MODE: null,
    TURN_ON_LIVE_MODE: null,

    PLAYBACK_INIT: null,
    PLAYBACK_GENERATE: null,
    PLAYBACK_CLEAR: null,
    PLAYBACK_GET_DATA: null,
});

export const WS_CHANNELS = {
    POS: 'pos',
    ALARM: 'alarm',
    NOTIFY: 'notify',
};

export const WS_ACTIONS = KeyMirror({
    WORKER_RUN: null,
    WORKER_STOP: null,
    WORKER_WEB_SOCKET_TURN_ON: null,
    WORKER_WEB_SOCKET_TURN_OFF: null,
    CHANGE_WORKER_PARAMS: null,
    PLAYBACK_CHANGE_PARAMS: null,
    PLAYBACK_CLEAR: null,
    PLAYBACK_POSITIONS: null,
    PLAYBACK_ALARMS: null,
    PLAYBACK_ERROR: null,
    PLAYBACK_INITIAL_POSITIONS: null,
    PLAYBACK_PENDING_REQUEST: null,
    PLAYBACK_RECEIVED_REQUEST: null,
    POSITIONS: null,
});

export const NOTIFY_ACTIONS = KeyMirror({
    UPDATE_TOKEN: null,

    COMPANY_CREATED: null,
    COMPANY_UPDATED: null,
    COMPANY_DELETED: null,

    ALARM_SET: null,
    ALARMS_UPDATED: null,
    ALARM_CLEAR: null,
    ALARMS: null,

    PROJECT_CREATED: null,
    PROJECT_UPDATED: null,
    PROJECT_DELETED: null,

    USER_CREATED: null,
    USER_UPDATED: null,
    USER_DELETED: null,

    PROJECT_USER_ACCESS_UPDATED: null,

    TRACKABLE_OBJECT_CREATED: null,
    TRACKABLE_OBJECT_UPDATED: null,
    TRACKABLE_OBJECT_DELETED: null,

    TRACKABLE_OBJECT_ASSOCIATION_CREATED: null,
    TRACKABLE_OBJECT_ASSOCIATION_UPDATED: null,

    GROUP_CREATED: null,
    GROUP_UPDATED: null,
    GROUP_DELETED: null,

    SHIFT_DELETED: null,

    ZONE_CREATED: null,
    ZONE_UPDATED: null,
    ZONE_DELETED: null,

    LOCATION_CREATED: null,
    LOCATION_UPDATED: null,
    LOCATION_DELETED: null,

    SUBLOCATION_CREATED: null,
    SUBLOCATION_UPDATED: null,
    SUBLOCATION_DELETED: null,

    FLOORPLAN_CREATED: null,
    FLOORPLAN_UPDATED: null,
    FLOORPLAN_DELETED: null,

    NODE_CREATED: null,
    NODE_UPDATED: null,
    NODE_DELETED: null,
    NODE_ASSIGN: null,
    NODE_RELEASE: null,
    
    WIN_ANCHOR_CREATED: null,
    WIN_ANCHOR_UPDATED: null,
    WIN_ANCHOR_DELETED: null,

    NOTIFICATION_CREATED: null,
    NOTIFICATION_UPDATED: null,
    NOTIFICATION_DELETED: null,

    SUBSCRIBER_CREATED: null,
    SUBSCRIBER_UPDATED: null,
    SUBSCRIBER_DELETED: null,

    SHM_SUBSCRIPTION_UPDATED: null,

    // Heartbeat
    HB: null,
    HBS: null,
});

export const PLAYBACK = {
    DELTA_TIME: 1000, // ms
    MAX_SIZE_TIME: 10 * 60 * 1000, // (in ms)
    MIN_SIZE_TIME: 2 * 60 * 1000, // (in ms)
    CRITICAL_LEVEL: 50 * 1000, // (in ms)
};

export const OBJECT_TYPE = {
    TYPE_OF_NO_HANDLER_ACTION: 'NONE',
    COMPANY_OBJECT: 'COMPANY',
    USER_OBJECT: 'USER',
    NODE: 'NODE',
};

export const SPAGHETTI_DEFAULTS = {
    IDLE_TIME: 3 * 60 * 1000,
    MINIMAL_DISTANCE: 500,
    TRAIL_COLORS: [
        'blue',
        'gold',
        'darkorange',
        'magenta',
        'green',
    ],
};
