import { WORKER_METHODS } from './common/constants';
import WebSocketHandler from './WebSocket/WebSocketHandler';

let ws;

self.addEventListener('message', (message) => {
    const { params, method } = message.data;

    switch (method) {
        case WORKER_METHODS.CLIENT_RECEIVED_POS:
            if (ws) ws.clientReceivedPos = true;
            break;

        case WORKER_METHODS.INIT:
            ws = new WebSocketHandler(params);
            break;

        case WORKER_METHODS.UPDATE_CONNECTION:
            ws.updateConnection(params);
            break;

        case WORKER_METHODS.UNSUBSCRIBE_ALL:
            ws.unsubscribedChannels = [...ws.openedChannels];
            ws.unsubscribe(ws.openedChannels);
            break;

        case WORKER_METHODS.SUBSCRIBE_ALL:
            ws.subscribe(ws.unsubscribedChannels);
            ws.unsubscribedChannels = [];
            break;

        case WORKER_METHODS.UNSUBSCRIBE:
            ws.unsubscribe(params);
            break;

        case WORKER_METHODS.SUBSCRIBE:
            ws.subscribe(params);
            break;

        case WORKER_METHODS.STOP:
            ws.clearParams();
            ws.close();
            break;

        case WORKER_METHODS.TURN_OFF_LIVE_MODE:
            ws.unsubscribe(['pos', 'alarm']);
            ws.stopUpdateInterval();
            break;

        case WORKER_METHODS.TURN_ON_LIVE_MODE:
            ws.subscribe(['pos', 'alarm']);
            ws.startUpdateInterval();
            break;

        default:
            // console.warn(`Not found method on Worker message: ${JSON.stringify(message)}.`);
    }
});
