#!/usr/bin/env bash
RTLS_FRONTEND_PREFIX=/usr/rtls/rtls-frontend

# If addons and build folders not exist
mkdir -p $RTLS_FRONTEND_PREFIX/client/addons
mkdir -p $RTLS_FRONTEND_PREFIX/client/build

cp -rf /tmp/rtls-frontend/client/addons $RTLS_FRONTEND_PREFIX/client/
cp -rf /tmp/rtls-frontend/client/build/client_config.js $RTLS_FRONTEND_PREFIX/client/build/

# Cleanup tmp folder
rm -rf /tmp/rtls-frontend

# for update beta version of SiteWise: BETA=true yum install rtls-frontend-***.rpm
if [ -z "$BETA" ]; then
  echo "Building SiteWise"
  npm run --prefix="${RTLS_FRONTEND_PREFIX}"/client build:prod
else
  echo "Building SiteWise Beta Version"
  npm run --prefix="${RTLS_FRONTEND_PREFIX}"/client build:beta
fi

if [ $? -eq 0 ]; then
    echo OK
else
    echo "!!!!!!!!!"
    echo "The rtls-frontend package (webpack) was not built because your server has low memory. Please reinstall the rtls-frontend package or increase the server parameters."
    echo "!!!!!!!!!"
    exit 1
fi

